diff -pruN 0.25.0~rc1-1/.appveyor.yml 0.25.1-1/.appveyor.yml
--- 0.25.0~rc1-1/.appveyor.yml	2024-02-17 23:32:31.000000000 +0000
+++ 0.25.1-1/.appveyor.yml	2024-04-04 14:21:38.000000000 +0000
@@ -1,4 +1,4 @@
-version: 0.25.0.{build}
+version: 0.25.1.{build}
 
 platform:
   - x86
@@ -96,8 +96,7 @@ build_script:
       }
   - bash -c "exec 0</dev/null && if [ \"$APPVEYOR_REPO_BRANCH\" == \"master\" -a -z \"$APPVEYOR_PULL_REQUEST_NUMBER\" ]; then ./bootstrap; fi"
   - bash -c "exec 0</dev/null && if [ \"$APPVEYOR_REPO_BRANCH\" == \"master\" -a -n \"$APPVEYOR_PULL_REQUEST_NUMBER\" ]; then ./bootstrap.ci -s \"-pr$APPVEYOR_PULL_REQUEST_NUMBER\"; fi"
-  - bash -c "exec 0</dev/null && if [ \"$APPVEYOR_REPO_BRANCH\" != \"master\" -a -z \"$APPVEYOR_PULL_REQUEST_NUMBER\" ]; then ./bootstrap.ci -s \"-$APPVEYOR_REPO_BRANCH\"; fi"
-  - bash -c "exec 0</dev/null && if [ \"$APPVEYOR_REPO_BRANCH\" != \"master\" -a -n \"$APPVEYOR_PULL_REQUEST_NUMBER\" ]; then ./bootstrap.ci -s \"-$APPVEYOR_REPO_BRANCH-prAPPVEYOR_PULL_REQUEST_NUMBER\"; fi"
+  - bash -c "exec 0</dev/null && if [ \"$APPVEYOR_REPO_BRANCH\" != \"master\" ]; then ./bootstrap; fi"
   # disable features to speed up the script
   - bash -c "exec 0</dev/null && ./configure --with-cygwin-native --disable-openssl --disable-readline --disable-zlib || cat config.log"
   - bash -c "exec 0</dev/null && rm src/getopt.h"
diff -pruN 0.25.0~rc1-1/.github/build.sh 0.25.1-1/.github/build.sh
--- 0.25.0~rc1-1/.github/build.sh	2024-02-17 23:32:31.000000000 +0000
+++ 0.25.1-1/.github/build.sh	2024-04-04 14:21:38.000000000 +0000
@@ -15,11 +15,6 @@ if [ "$GITHUB_EVENT_NAME" == "pull_reque
 	else
 		SUFFIX="$GITHUB_BASE_REF-pr$PR_NUMBER"
 	fi
-else
-	BRANCH=$(echo $GITHUB_REF | awk 'BEGIN { FS = "/" } ; { print $3 }')
-	if [ "$BRANCH" != "master" ]; then
-		SUFFIX="$BRANCH"
-	fi
 fi
 if [ -n "$SUFFIX" ]; then
 	./bootstrap.ci -s "$SUFFIX"
@@ -54,7 +49,7 @@ else
 	fi
 	# normal procedure
 
-	CONFIGURE_FLAGS="--disable-dependency-tracking"
+	CONFIGURE_FLAGS="--disable-dependency-tracking --enable-doc"
 	if [ "$1" == "piv-sm" ]; then
 		CONFIGURE_FLAGS="$CONFIGURE_FLAGS --enable-piv-sm"
 	fi
@@ -92,6 +87,7 @@ fi
 # this is broken in old ubuntu
 if [ "$1" == "dist" -o "$2" == "dist" ]; then
 	set +e
+	DISTCHECK_CONFIGURE_FLAGS="$CONFIGURE_FLAGS"
 	make distcheck
 	RV=$?
 	if [ $RV -ne 0 ]; then
diff -pruN 0.25.0~rc1-1/.github/restart-pcscd.sh 0.25.1-1/.github/restart-pcscd.sh
--- 0.25.0~rc1-1/.github/restart-pcscd.sh	2024-02-17 23:32:31.000000000 +0000
+++ 0.25.1-1/.github/restart-pcscd.sh	2024-04-04 14:21:38.000000000 +0000
@@ -3,6 +3,8 @@
 # This file is made to be sourced into other test scripts and not executed
 # manually because it sets trap to restore pcscd to working state
 
+# Set PCSCD_DEBUG="-d -a" to debug APDUs before sourcing this file
+
 # register cleanup handler
 function pcscd_cleanup {
 	echo "Process terminated: resetting pcscd"
@@ -20,13 +22,14 @@ if which systemctl && systemctl is-syste
 else
 	sudo pkill pcscd || echo "no pcscd process was running"
 fi
-sudo /usr/sbin/pcscd -f 2>&1 | sed -e 's/^/pcscd: /;' &
+sudo /usr/sbin/pcscd -f $PCSCD_DEBUG 2>&1 | sed -e 's/^/pcscd: /' &
 
 
 # Try to wait up to 30 seconds for pcscd to come up and create PID file
 for ((i=1;i<=30;i++)); do
 	echo "Waiting for pcscd to start: $i s"
 	if [ -f "/var/run/pcscd/pcscd.pid" ]; then
+		echo "PCSC PID: `cat /var/run/pcscd/pcscd.pid`"
 		break
 	fi
 	sleep 1
diff -pruN 0.25.0~rc1-1/.github/test-openpgp.sh 0.25.1-1/.github/test-openpgp.sh
--- 0.25.0~rc1-1/.github/test-openpgp.sh	2024-02-17 23:32:31.000000000 +0000
+++ 0.25.1-1/.github/test-openpgp.sh	2024-04-04 14:21:38.000000000 +0000
@@ -2,6 +2,8 @@
 
 set -ex -o xtrace
 
+uname -a
+
 source .github/setup-valgrind.sh
 
 # install the opensc
@@ -26,12 +28,35 @@ echo "com.licel.jcardsim.vsmartcard.port
 
 
 # prepare pcscd
+PCSCD_DEBUG="-d -a"
 . .github/restart-pcscd.sh
 
+sleep 5
+echo "Is pcscd running:"
+ps -ef | grep  pcscd
+
+echo "Test for /var/run/pcscd/"
+if [ -d /var/run/pcscd/ ] ; then
+	ls -la /var/run/pcscd/*
+	if [ -f /var/run/pcscd/pcscd.pid ] ; then
+		echo "/var/run/pcscd/pcscd.pid `cat /var/run/pcscd/pcscd.pid`"
+	fi
+fi
+
+echo "Test for /run/pcscd/"
+if [ -d /run/pcscd/ ] ; then
+	ls -la /run/pcscd/*
+	if [ -f /run/pcscd/pcscd.pid ] ; then
+		echo "/run/pcscd/pcscd.pid `cat /run/pcscd/pcscd.pid`" 
+	fi
+
+fi
+ps  -ef |  grep pcsc
 
 # start the applet and run couple of commands against that
 java -noverify -cp ykneo-openpgp/applet/bin:jcardsim/target/jcardsim-3.0.5-SNAPSHOT.jar com.licel.jcardsim.remote.VSmartCard openpgp_jcardsim.cfg >/dev/null &
 PID=$!;
+echo java pid $PID
 sleep 5;
 $VALGRIND opensc-tool --card-driver default --send-apdu 80b800002210D276000124010200000000000001000010D276000124010200000000000001000000;
 $VALGRIND opensc-tool -n;
@@ -52,3 +77,4 @@ diff -u3 src/tests/p11test/openpgp_s0{_r
 diff -u3 src/tests/p11test/openpgp_s1{_ref,}.json
 
 kill -9 $PID
+ps -ef | grep pcsc
diff -pruN 0.25.0~rc1-1/.gitignore 0.25.1-1/.gitignore
--- 0.25.0~rc1-1/.gitignore	2024-02-17 23:32:31.000000000 +0000
+++ 0.25.1-1/.gitignore	2024-04-04 14:21:38.000000000 +0000
@@ -148,3 +148,5 @@ src/tests/fuzzing/fuzz_pkcs15init
 src/tests/fuzzing/fuzz_scconf_parse_string
 
 version.m4.ci
+openssl_arm64
+openssl_bin
diff -pruN 0.25.0~rc1-1/NEWS 0.25.1-1/NEWS
--- 0.25.0~rc1-1/NEWS	2024-02-17 23:32:31.000000000 +0000
+++ 0.25.1-1/NEWS	2024-04-04 14:21:38.000000000 +0000
@@ -1,6 +1,15 @@
 NEWS for OpenSC -- History of user visible changes
 
-# New in 0.25.0; 2024-02-XX
+# New in 0.25.0; 2024-04-05
+
+## General improvements
+* Add missing file to dist tarball to build documentation (#3063)
+
+## minidriver
+* Fix RSA decryption with PKCS#1 v1.5 padding (#3077)
+* Fix crash when app is not set (#3084)
+
+# New in 0.25.0; 2024-03-06
 ## Security
 * [CVE-2023-5992](https://github.com/OpenSC/OpenSC/wiki/CVE-2023-5992): Side-channel leaks while stripping encryption PKCS#1.5 padding in OpenSC (#2948)
 * [CVE-2024-1454](https://github.com/OpenSC/OpenSC/wiki/CVE-2024-1454): Potential use-after-free in AuthentIC driver during card enrollment in pkcs15init (#2962)
@@ -23,21 +32,27 @@ NEWS for OpenSC -- History of user visib
 * Simplify printing EC keys parameters (#2960)
 * Add option to import GENERIC key (#2955)
 * Add support for importing Ed25518/448 keys (#2985)
+## drust-tool
+* Add tool for D-Trust cards (#3026, #3051)
 ## IDPrime
 * Support uncompressed certificates on IDPrime 940 (#2958)
 * Enhance IDPrime logging (#3003)
+* Add SafeNet 5110+ FIPS token support (#3048)
 ## D-Trust Signature Cards
 * Add support for RSA D-Trust Signature Card 4.1 and 4.4 (#2943)
 ## EstEID
 * Remove expired EstEID 3.* card support (#2950)
 ## ePass2003
 * Allow SW implementation with more SHA2 hashes and ECDSA (#3012)
+* Fix EC key generation (#3045)
 ## SmartCard-HSM
 * Fix SELECT APDU command (#2978)
 ## MyEID
 * Update for PKCS#15 profile (#2965)
 ## Rutoken
 * Support for RSA 4096 key algorithm (#3011)
+## OpenPGP
+* Fix decryption requiting Manage Security Environment for authentication key (#3042)
 
 # New in 0.24.0; 2023-12-13
 ## Security
diff -pruN 0.25.0~rc1-1/README 0.25.1-1/README
--- 0.25.0~rc1-1/README	2024-02-17 23:32:31.000000000 +0000
+++ 0.25.1-1/README	2024-04-04 14:21:38.000000000 +0000
@@ -1,23 +1,27 @@
 # OpenSC documentation
 
-
-Wiki is [available online](https://github.com/OpenSC/OpenSC/wiki)
-
-Please take a look at the documentation before trying to use OpenSC.
-
-Do NOT use any links from wiki to download the OpenSC because wiki can be modified by anybody, see
-[#2554](https://github.com/OpenSC/OpenSC/issues/2554). For downloading OpenSC, use the links here in README.
+Manual pages for the
+[OpenSC command line tools](https://htmlpreview.github.io/?https://github.com/OpenSC/OpenSC/blob/master/doc/tools/tools.html)
+as well as for the
+[OpenSC configuration files](https://htmlpreview.github.io/?https://github.com/OpenSC/OpenSC/blob/master/doc/files/files.html)
+are available online and typically distributed along with your installation.
+
+The [OpenSC Wiki](https://github.com/OpenSC/OpenSC/wiki) includes, among others, information for:
+ * [Windows Quick Start](https://github.com/OpenSC/OpenSC/wiki/Windows-Quick-Start)
+ * [macOS Quick Start](https://github.com/OpenSC/OpenSC/wiki/macOS-Quick-Start)
+ * [Compiling and Installing on Unix flavors](https://github.com/OpenSC/OpenSC/wiki/Compiling-and-Installing-on-Unix-flavors)
+ * [Frequently Asked Questions](https://github.com/OpenSC/OpenSC/wiki/Frequently-Asked-Questions)
+ * More user and developer provided documentation
 
 # Downloads
 
-[OpenSC 0.24.0](https://github.com/OpenSC/OpenSC/releases/tag/0.24.0) is the latest stable version released on
-13.12.2023. It is available as
+## Latest release
+
+The [latest stable version of OpenSC](https://github.com/OpenSC/OpenSC/releases/latest) is available on Github.  It is available as
 
- * Windows installer
-   * [OpenSC-0.24.0_win64.msi](https://github.com/OpenSC/OpenSC/releases/download/0.24.0/OpenSC-0.24.0_win64.msi) for 64 bit programs
-   * [OpenSC-0.24.0_win32.msi](https://github.com/OpenSC/OpenSC/releases/download/0.24.0/OpenSC-0.24.0_win32.msi) for 32 bit programs
- * [OpenSC-0.24.0.dmg](https://github.com/OpenSC/OpenSC/releases/download/0.24.0/OpenSC-0.24.0.dmg): macOS installer
- * [opensc-0.24.0.tar.gz](https://github.com/OpenSC/OpenSC/releases/download/0.24.0/opensc-0.24.0.tar.gz): Source code distribution
+ * Windows installer for 64 bit and 32 bit programs (`OpenSC*_win64.msi` and `OpenSC*_win32.msi`)
+ * macOS installer (`OpenSC*.dmg`)
+ * Source code distribution (`opensc*.tar.gz`)
 
 ## Nightly build
 
@@ -29,7 +33,7 @@ Nightly builds are available by their gi
 
 [![Linux build](https://github.com/OpenSC/OpenSC/actions/workflows/linux.yml/badge.svg)](https://github.com/OpenSC/OpenSC/actions/workflows/linux.yml)
 [![OSX build](https://github.com/OpenSC/OpenSC/actions/workflows/macos.yml/badge.svg)](https://github.com/OpenSC/OpenSC/actions/workflows/macos.yml)
-[![AppVeyor CI Build Status](https://ci.appveyor.com/api/projects/status/github/OpenSC/OpenSC?branch=master&svg=true)](https://ci.appveyor.com/project/LudovicRousseau/OpenSC/branch/master)
+[![AppVeyor CI Build Status](https://ci.appveyor.com/api/projects/status/github/OpenSC/OpenSC?branch=master&svg=true)](https://ci.appveyor.com/project/frankmorgner/opensc/branch/master)
 [![Coverity Scan Status](https://scan.coverity.com/projects/4026/badge.svg)](https://scan.coverity.com/projects/4026)
 [![CodeQL](https://github.com/OpenSC/OpenSC/actions/workflows/codeql.yml/badge.svg?event=push)](https://github.com/OpenSC/OpenSC/actions/workflows/codeql.yml)
 [![Fuzzing Status](https://oss-fuzz-build-logs.storage.googleapis.com/badges/opensc.svg)](https://bugs.chromium.org/p/oss-fuzz/issues/list?sort=-opened&can=1&q=proj:opensc)
@@ -38,7 +42,7 @@ Nightly builds are available by their gi
 Build and test status of specific cards:
 
 | Cards                                                               | Status                                                                                                                            |
-|---------------------------------------------------------------------|-----------------------------------------------------------------------------------------------------------------------------------|
+|----------------------------------------------------------------------|-----------------------------------------------------------------------------------------------------------------------------------|
 | CAC                                                                 | [![CAC](https://gitlab.com/redhat-crypto/OpenSC/badges/cac/pipeline.svg)](https://gitlab.com/redhat-crypto/OpenSC/pipelines)      |
 | [virt_CACard](https://github.com/Jakuje/virt_cacard)                | [![virt_CACard](https://github.com/OpenSC/OpenSC/actions/workflows/linux.yml/badge.svg)](https://github.com/OpenSC/OpenSC/actions/workflows/linux.yml) |
 | [Coolkey](https://github.com/dogtagpki/coolkey/tree/master/applet)  | [![Coolkey](https://gitlab.com/redhat-crypto/OpenSC/badges/coolkey/pipeline.svg)](https://gitlab.com/redhat-crypto/OpenSC/pipelines) |
diff -pruN 0.25.0~rc1-1/README.md 0.25.1-1/README.md
--- 0.25.0~rc1-1/README.md	2024-02-17 23:32:31.000000000 +0000
+++ 0.25.1-1/README.md	2024-04-04 14:21:38.000000000 +0000
@@ -1,23 +1,27 @@
 # OpenSC documentation
 
-
-Wiki is [available online](https://github.com/OpenSC/OpenSC/wiki)
-
-Please take a look at the documentation before trying to use OpenSC.
-
-Do NOT use any links from wiki to download the OpenSC because wiki can be modified by anybody, see
-[#2554](https://github.com/OpenSC/OpenSC/issues/2554). For downloading OpenSC, use the links here in README.
+Manual pages for the
+[OpenSC command line tools](https://htmlpreview.github.io/?https://github.com/OpenSC/OpenSC/blob/master/doc/tools/tools.html)
+as well as for the
+[OpenSC configuration files](https://htmlpreview.github.io/?https://github.com/OpenSC/OpenSC/blob/master/doc/files/files.html)
+are available online and typically distributed along with your installation.
+
+The [OpenSC Wiki](https://github.com/OpenSC/OpenSC/wiki) includes, among others, information for:
+ * [Windows Quick Start](https://github.com/OpenSC/OpenSC/wiki/Windows-Quick-Start)
+ * [macOS Quick Start](https://github.com/OpenSC/OpenSC/wiki/macOS-Quick-Start)
+ * [Compiling and Installing on Unix flavors](https://github.com/OpenSC/OpenSC/wiki/Compiling-and-Installing-on-Unix-flavors)
+ * [Frequently Asked Questions](https://github.com/OpenSC/OpenSC/wiki/Frequently-Asked-Questions)
+ * More user and developer provided documentation
 
 # Downloads
 
-[OpenSC 0.24.0](https://github.com/OpenSC/OpenSC/releases/tag/0.24.0) is the latest stable version released on
-13.12.2023. It is available as
+## Latest release
+
+The [latest stable version of OpenSC](https://github.com/OpenSC/OpenSC/releases/latest) is available on Github.  It is available as
 
- * Windows installer
-   * [OpenSC-0.24.0_win64.msi](https://github.com/OpenSC/OpenSC/releases/download/0.24.0/OpenSC-0.24.0_win64.msi) for 64 bit programs
-   * [OpenSC-0.24.0_win32.msi](https://github.com/OpenSC/OpenSC/releases/download/0.24.0/OpenSC-0.24.0_win32.msi) for 32 bit programs
- * [OpenSC-0.24.0.dmg](https://github.com/OpenSC/OpenSC/releases/download/0.24.0/OpenSC-0.24.0.dmg): macOS installer
- * [opensc-0.24.0.tar.gz](https://github.com/OpenSC/OpenSC/releases/download/0.24.0/opensc-0.24.0.tar.gz): Source code distribution
+ * Windows installer for 64 bit and 32 bit programs (`OpenSC*_win64.msi` and `OpenSC*_win32.msi`)
+ * macOS installer (`OpenSC*.dmg`)
+ * Source code distribution (`opensc*.tar.gz`)
 
 ## Nightly build
 
@@ -29,7 +33,7 @@ Nightly builds are available by their gi
 
 [![Linux build](https://github.com/OpenSC/OpenSC/actions/workflows/linux.yml/badge.svg)](https://github.com/OpenSC/OpenSC/actions/workflows/linux.yml)
 [![OSX build](https://github.com/OpenSC/OpenSC/actions/workflows/macos.yml/badge.svg)](https://github.com/OpenSC/OpenSC/actions/workflows/macos.yml)
-[![AppVeyor CI Build Status](https://ci.appveyor.com/api/projects/status/github/OpenSC/OpenSC?branch=master&svg=true)](https://ci.appveyor.com/project/LudovicRousseau/OpenSC/branch/master)
+[![AppVeyor CI Build Status](https://ci.appveyor.com/api/projects/status/github/OpenSC/OpenSC?branch=master&svg=true)](https://ci.appveyor.com/project/frankmorgner/opensc/branch/master)
 [![Coverity Scan Status](https://scan.coverity.com/projects/4026/badge.svg)](https://scan.coverity.com/projects/4026)
 [![CodeQL](https://github.com/OpenSC/OpenSC/actions/workflows/codeql.yml/badge.svg?event=push)](https://github.com/OpenSC/OpenSC/actions/workflows/codeql.yml)
 [![Fuzzing Status](https://oss-fuzz-build-logs.storage.googleapis.com/badges/opensc.svg)](https://bugs.chromium.org/p/oss-fuzz/issues/list?sort=-opened&can=1&q=proj:opensc)
@@ -38,7 +42,7 @@ Nightly builds are available by their gi
 Build and test status of specific cards:
 
 | Cards                                                               | Status                                                                                                                            |
-|---------------------------------------------------------------------|-----------------------------------------------------------------------------------------------------------------------------------|
+|----------------------------------------------------------------------|-----------------------------------------------------------------------------------------------------------------------------------|
 | CAC                                                                 | [![CAC](https://gitlab.com/redhat-crypto/OpenSC/badges/cac/pipeline.svg)](https://gitlab.com/redhat-crypto/OpenSC/pipelines)      |
 | [virt_CACard](https://github.com/Jakuje/virt_cacard)                | [![virt_CACard](https://github.com/OpenSC/OpenSC/actions/workflows/linux.yml/badge.svg)](https://github.com/OpenSC/OpenSC/actions/workflows/linux.yml) |
 | [Coolkey](https://github.com/dogtagpki/coolkey/tree/master/applet)  | [![Coolkey](https://gitlab.com/redhat-crypto/OpenSC/badges/coolkey/pipeline.svg)](https://gitlab.com/redhat-crypto/OpenSC/pipelines) |
diff -pruN 0.25.0~rc1-1/SECURITY.md 0.25.1-1/SECURITY.md
--- 0.25.0~rc1-1/SECURITY.md	2024-02-17 23:32:31.000000000 +0000
+++ 0.25.1-1/SECURITY.md	2024-04-04 14:21:38.000000000 +0000
@@ -9,8 +9,8 @@ backport security fixes into them. Only
 
 | Version  | Supported          |
 | -------- | ------------------ |
-| 0.25.0   | :white_check_mark: |
-| < 0.25.0 | :x:                |
+| 0.25.1   | :white_check_mark: |
+| < 0.25.1 | :x:                |
 
 ## Reporting a Vulnerability
 
diff -pruN 0.25.0~rc1-1/configure.ac 0.25.1-1/configure.ac
--- 0.25.0~rc1-1/configure.ac	2024-02-17 23:32:31.000000000 +0000
+++ 0.25.1-1/configure.ac	2024-04-04 14:21:38.000000000 +0000
@@ -8,8 +8,8 @@ define([PRODUCT_BUGREPORT], [https://git
 define([PRODUCT_URL], [https://github.com/OpenSC/OpenSC])
 define([PACKAGE_VERSION_MAJOR], [0])
 define([PACKAGE_VERSION_MINOR], [25])
-define([PACKAGE_VERSION_FIX], [0])
-define([PACKAGE_SUFFIX], [-rc1])
+define([PACKAGE_VERSION_FIX], [1])
+define([PACKAGE_SUFFIX], [])
 
 define([VS_FF_LEGAL_COPYRIGHT], [OpenSC Project])
 define([VS_FF_LEGAL_COMPANY_NAME], [OpenSC Project])
@@ -48,7 +48,7 @@ OPENSC_VS_FF_PRODUCT_URL="VS_FF_PRODUCT_
 #   (Interfaces added:                  CURRENT++, REVISION=0)
 OPENSC_LT_CURRENT="11"
 OPENSC_LT_OLDEST="11"
-OPENSC_LT_REVISION="0"
+OPENSC_LT_REVISION="2"
 OPENSC_LT_AGE="$((${OPENSC_LT_CURRENT}-${OPENSC_LT_OLDEST}))"
 
 AC_CONFIG_SRCDIR([src/libopensc/sc.c])
diff -pruN 0.25.0~rc1-1/debian/changelog 0.25.1-1/debian/changelog
--- 0.25.0~rc1-1/debian/changelog	2024-02-18 13:38:58.000000000 +0000
+++ 0.25.1-1/debian/changelog	2024-07-03 20:26:51.000000000 +0000
@@ -1,3 +1,10 @@
+opensc (0.25.1-1) unstable; urgency=medium
+
+  * Team upload
+  * New upstream release
+
+ -- Bastian Germann <bage@debian.org>  Wed, 03 Jul 2024 22:26:51 +0200
+
 opensc (0.25.0~rc1-1) unstable; urgency=medium
 
   * Team upload
diff -pruN 0.25.0~rc1-1/doc/Makefile.am 0.25.1-1/doc/Makefile.am
--- 0.25.0~rc1-1/doc/Makefile.am	2024-02-17 23:32:31.000000000 +0000
+++ 0.25.1-1/doc/Makefile.am	2024-04-04 14:21:38.000000000 +0000
@@ -2,5 +2,5 @@ MAINTAINERCLEANFILES = $(srcdir)/Makefil
 
 SUBDIRS = tools files
 
-dist_noinst_SCRIPTS = html.xsl man.xsl
+dist_noinst_SCRIPTS = html.xsl docbook-utf8.xsl man.xsl
 dist_noinst_DATA = api.css
diff -pruN 0.25.0~rc1-1/doc/docbook-utf8.xsl 0.25.1-1/doc/docbook-utf8.xsl
--- 0.25.0~rc1-1/doc/docbook-utf8.xsl	1970-01-01 00:00:00.000000000 +0000
+++ 0.25.1-1/doc/docbook-utf8.xsl	2024-04-04 14:21:38.000000000 +0000
@@ -0,0 +1,10 @@
+<?xml version='1.0'?>
+<xsl:stylesheet  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
+                 version="1.0">
+
+<xsl:import href="docbook.xsl"/>
+<xsl:output method="html"
+            encoding="UTF-8"
+            indent="no"/>
+
+</xsl:stylesheet>
diff -pruN 0.25.0~rc1-1/doc/files/files.html 0.25.1-1/doc/files/files.html
--- 0.25.0~rc1-1/doc/files/files.html	2024-02-17 23:32:31.000000000 +0000
+++ 0.25.1-1/doc/files/files.html	2024-04-04 14:21:38.000000000 +0000
@@ -1,4 +1,4 @@
-<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>OpenSC Manual Pages: Section 5</title><meta name="generator" content="DocBook XSL Stylesheets V1.79.1"><style type="text/css"><!--
+<html><head><meta http-equiv="Content-Type" content="text/html; charset=UTF-8"><title>OpenSC Manual Pages: Section 5</title><meta name="generator" content="DocBook XSL Stylesheets Vsnapshot"><style type="text/css"><!--
 			body {
   font-family: Verdana, Arial;
   font-size: 0.9em;
@@ -43,7 +43,7 @@ span.errortext {
   font-style: italic;
 }
 
-		--></style></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book"><div class="titlepage"><div><div><h1 class="title"><a name="id-1"></a>OpenSC Manual Pages: Section 5</h1></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl class="toc"><dt><span class="refentrytitle"><a href="#opensc.conf">opensc.conf</a></span><span class="refpurpose"> &#8212; configuration file for OpenSC</span></dt><dt><span class="refentrytitle"><a href="#pkcs15-profile">pkcs15-profile</a></span><span class="refpurpose"> &#8212; format of profile for <span class="command"><strong>pkcs15-init</strong></span></span></dt></dl></div><div class="refentry"><a name="opensc.conf"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>opensc.conf &#8212; configuration file for OpenSC</p></div><div class="refsect1"><a name="id-1.2.3"></a><h2>Description</h2><p>
+		--></style></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book"><div class="titlepage"><div><div><h1 class="title"><a name="id-1"></a>OpenSC Manual Pages: Section 5</h1></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl class="toc"><dt><span class="refentrytitle"><a href="#opensc.conf">opensc.conf</a></span><span class="refpurpose"> — configuration file for OpenSC</span></dt><dt><span class="refentrytitle"><a href="#pkcs15-profile">pkcs15-profile</a></span><span class="refpurpose"> — format of profile for <span class="command"><strong>pkcs15-init</strong></span></span></dt></dl></div><div class="refentry"><a name="opensc.conf"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>opensc.conf — configuration file for OpenSC</p></div><div class="refsect1"><a name="id-1.2.3"></a><h2>Description</h2><p>
 			OpenSC obtains configuration data from the following sources in the following order
 			</p><div class="orderedlist"><ol class="orderedlist" type="1"><li class="listitem"><p>
 						command-line options
@@ -57,7 +57,7 @@ span.errortext {
 						<code class="literal">HKEY_LOCAL_MACHINE</code> (if available)
 				</p></li><li class="listitem"><p>
 						system-wide configuration file
-						(<code class="literal">/usr/etc/opensc.conf</code>)
+						(<code class="literal">/etc/opensc.conf</code>)
 				</p></li></ol></div><p>
 		</p><p>
 			The configuration file, <code class="literal">opensc.conf</code>, is composed
@@ -89,6 +89,8 @@ app <em class="replaceable"><code>applic
 			<em class="replaceable"><code>application</code></em>
 			specifies one of:
 			</p><div class="itemizedlist"><ul class="itemizedlist" style="list-style-type: disc; "><li class="listitem"><p>
+						<code class="literal"><em class="replaceable"><code>filename</code></em></code>: Configuration block for the application with specified file path.
+				</p></li><li class="listitem"><p>
 						<code class="literal">default</code>: The fall-back configuration block for all applications
 				</p></li><li class="listitem"><p>
 						<code class="literal">opensc-pkcs11</code>: Configuration block for the PKCS#11 module (<code class="filename">opensc-pkcs11.so</code>)
@@ -143,7 +145,7 @@ app <em class="replaceable"><code>applic
 					<code class="option">profile_dir = <em class="replaceable"><code>filename</code></em>;</code>
 				</span></dt><dd><p>
 						PKCS#15 initialization/personalization profiles
-						directory for 
+						directory for
 						<span class="citerefentry"><span class="refentrytitle">pkcs15-init</span>(1).
 						</span>
 						(Default: <code class="literal">/usr/share/opensc</code>).
@@ -212,16 +214,16 @@ app <em class="replaceable"><code>applic
 				</span></dt><dd><p>
 						Configuration of the smart card reader driver where <em class="replaceable"><code>name</code></em> is one of:
 						</p><div class="itemizedlist"><ul class="itemizedlist" style="list-style-type: disc; "><li class="listitem"><p>
-									<code class="literal">ctapi</code>: See <a class="xref" href="#ctapi" title="Configuration of CT-API Readers">the section called &#8220;Configuration of CT-API Readers&#8221;</a>
+									<code class="literal">ctapi</code>: See <a class="xref" href="#ctapi" title="Configuration of CT-API Readers">the section called “Configuration of CT-API Readers”</a>
 								</p></li><li class="listitem"><p>
-									<code class="literal">pcsc</code>: See <a class="xref" href="#pcsc" title="Configuration of PC/SC Readers">the section called &#8220;Configuration of PC/SC Readers&#8221;</a>
+									<code class="literal">pcsc</code>: See <a class="xref" href="#pcsc" title="Configuration of PC/SC Readers">the section called “Configuration of PC/SC Readers”</a>
 							</p></li><li class="listitem"><p>
-									<code class="literal">openct</code>: See <a class="xref" href="#openct" title="Configuration of OpenCT Readers">the section called &#8220;Configuration of OpenCT Readers&#8221;</a>
+									<code class="literal">openct</code>: See <a class="xref" href="#openct" title="Configuration of OpenCT Readers">the section called “Configuration of OpenCT Readers”</a>
 							</p></li><li class="listitem"><p>
 									<code class="literal">cryptotokenkit</code>: Configuration block for CryptoTokenKit readers
 							</p></li></ul></div><p>
 					</p><p>
-						See <a class="xref" href="#reader_driver" title="Configuration of Smart Card Reader Driver">the section called &#8220;Configuration of Smart Card Reader Driver&#8221;</a>.
+						See <a class="xref" href="#reader_driver" title="Configuration of Smart Card Reader Driver">the section called “Configuration of Smart Card Reader Driver”</a>.
 					</p></dd><dt><span class="term">
 					<code class="option">card_driver <em class="replaceable"><code>name</code></em> {
 						<em class="replaceable"><code>block_contents</code></em>
@@ -230,13 +232,15 @@ app <em class="replaceable"><code>applic
 				</span></dt><dd><p>
 						Configuration of the card driver where <em class="replaceable"><code>name</code></em> is one of:
 						</p><div class="itemizedlist"><ul class="itemizedlist" style="list-style-type: disc; "><li class="listitem"><p>
-									<code class="literal">npa</code>: See <a class="xref" href="#npa" title="Configuration Options for German ID Card">the section called &#8220;Configuration Options for German ID Card&#8221;</a>
+									<code class="literal">npa</code>: See <a class="xref" href="#npa" title="Configuration Options for German ID Card">the section called “Configuration Options for German ID Card”</a>
+							</p></li><li class="listitem"><p>
+									<code class="literal">dnie</code>: See <a class="xref" href="#dnie" title="Configuration Options for DNIe">the section called “Configuration Options for DNIe”</a>
 							</p></li><li class="listitem"><p>
-									<code class="literal">dnie</code>: See <a class="xref" href="#dnie" title="Configuration Options for DNIe">the section called &#8220;Configuration Options for DNIe&#8221;</a>
+									<code class="literal">edo</code>: See <a class="xref" href="#edo" title="Configuration Options for Polish eID Card">the section called “Configuration Options for Polish eID Card”</a>
 							</p></li><li class="listitem"><p>
-									<code class="literal">edo</code>: See <a class="xref" href="#edo" title="Configuration Options for Polish eID Card">the section called &#8220;Configuration Options for Polish eID Card&#8221;</a>
+									<code class="literal">eoi</code>: See <a class="xref" href="#eoi" title="Configuration Options for Slovenian eID Card">the section called “Configuration Options for Slovenian eID Card”</a>
 							</p></li><li class="listitem"><p>
-									<code class="literal">myeid</code>: See <a class="xref" href="#myeid" title="Configuration Options for MyEID Card">the section called &#8220;Configuration Options for MyEID Card&#8221;</a>
+									<code class="literal">myeid</code>: See <a class="xref" href="#myeid" title="Configuration Options for MyEID Card">the section called “Configuration Options for MyEID Card”</a>
 							</p></li><li class="listitem"><p>
 									Any other value: Configuration block for an externally loaded card driver
 							</p></li></ul></div><p>
@@ -251,27 +255,26 @@ app <em class="replaceable"><code>applic
 						the driver using the <code class="option">card_atr</code>
 						block.
 					</p><p>
-						For details see <a class="xref" href="#card_atr" title="Configuration based on ATR">the section called &#8220;Configuration based on ATR&#8221;</a>.
+						For details see <a class="xref" href="#card_atr" title="Configuration based on ATR">the section called “Configuration based on ATR”</a>.
 					</p></dd><dt><span class="term">
-						<code class="option">disable_hw_pkcs1_padding = <em class="replaceable"><code>value</code></em>;</code>
-					</span></dt><dd><p>
+					<code class="option">disable_hw_pkcs1_padding = <em class="replaceable"><code>value</code></em>;</code>
+				</span></dt><dd><p>
 						Disabling PKCS#1 v1.5 padding in HW when card supports doing raw RSA operations.
 						Known parameters:
-					</p><div class="itemizedlist"><ul class="itemizedlist" style="list-style-type: disc; "><li class="listitem"><p>
-									<code class="literal">no</code>:
-									PKCS#1 v1.5 padding is enabled in HW when card supports it.
+						</p><div class="itemizedlist"><ul class="itemizedlist" style="list-style-type: disc; "><li class="listitem"><p>
+									<code class="literal">no</code>: PKCS#1 v1.5 padding is enabled in HW when card supports it.
 							</p></li><li class="listitem"><p>
 									<code class="literal">sign</code>: PKCS#1 v1.5 padding
-									is disabled only for signatures (PKCS#1 v1.5 type 1).
+								is disabled only for signatures (PKCS#1 v1.5 type 1).
 							</p></li><li class="listitem"><p>
 									<code class="literal">decipher</code>: PKCS#1 v1.5 padding
-									is disabled only for decryption (PKCS#1 v1.5 type 2).
+								is disabled only for decryption (PKCS#1 v1.5 type 2).
 							</p></li><li class="listitem"><p>
 									<code class="literal">both</code>: PKCS#1 v1.5 padding
-									is disabled both for signatures and decryption (PKCS#1 v1.5 type 1 and 2).
+								is disabled both for signatures and decryption (PKCS#1 v1.5 type 1 and 2).
 							</p></li></ul></div><p>
-							(Default: <code class="literal">decipher</code>).
-					</p></dd><dt><span class="term">
+						(Default: <code class="literal">decipher</code>).
+				</p></dd><dt><span class="term">
 					<code class="option">secure_messaging <em class="replaceable"><code>name</code></em> {
 						<em class="replaceable"><code>block_contents</code></em>
 						}
@@ -286,7 +289,7 @@ app <em class="replaceable"><code>applic
 								<code class="option">module_path = <em class="replaceable"><code>filename</code></em>;</code>
 							</span></dt><dd><p>
 									Directory with external SM module
-									(Default: /usr/lib).
+									(Default: /usr/lib64).
 								</p><p>
 									If this configuration value is not
 									found on Windows, the registry key
@@ -348,9 +351,9 @@ app <em class="replaceable"><code>applic
 				</span></dt><dd><p>
 						Internal configuration options where <em class="replaceable"><code>name</code></em> is one of:
 						</p><div class="itemizedlist"><ul class="itemizedlist" style="list-style-type: disc; "><li class="listitem"><p>
-									<code class="literal">pkcs15</code>: See <a class="xref" href="#framework%20pkcs15" title="Configuration of PKCS#15 Framework">the section called &#8220;Configuration of PKCS#15 Framework&#8221;</a>
+									<code class="literal">pkcs15</code>: See <a class="xref" href="#framework%20pkcs15" title="Configuration of PKCS#15 Framework">the section called “Configuration of PKCS#15 Framework”</a>
 							</p></li><li class="listitem"><p>
-									<code class="literal">tokend</code>: See <a class="xref" href="#framework%20tokend" title="Configuration of Tokend">the section called &#8220;Configuration of Tokend&#8221;</a>
+									<code class="literal">tokend</code>: See <a class="xref" href="#framework%20tokend" title="Configuration of Tokend">the section called “Configuration of Tokend”</a>
 							</p></li></ul></div><p>
 					</p></dd><dt><span class="term">
 					<code class="option">pkcs11 {
@@ -360,7 +363,7 @@ app <em class="replaceable"><code>applic
 				</span></dt><dd><p>
 						Parameters for the OpenSC PKCS11 module.
 					</p><p>
-						For details see <a class="xref" href="#pkcs11" title="Configuration of PKCS#11">the section called &#8220;Configuration of PKCS#11&#8221;</a>.
+						For details see <a class="xref" href="#pkcs11" title="Configuration of PKCS#11">the section called “Configuration of PKCS#11”</a>.
 					</p></dd></dl></div><div class="refsect2"><a name="reader_driver"></a><h3>Configuration of Smart Card Reader Driver</h3><div class="refsect3"><a name="id-1.2.4.3.2"></a><h4>Configuration Options for all Reader Drivers</h4><div class="variablelist"><dl class="variablelist"><dt><span class="term">
 							<code class="option">max_send_size = <em class="replaceable"><code>num</code></em>;</code>
 							<code class="option">max_recv_size = <em class="replaceable"><code>num</code></em>;</code>
@@ -478,8 +481,8 @@ app <em class="replaceable"><code>applic
 							card driver will do everything
 							necessary before sending the data
 							(hash code) to the card.
-						</p><p>
-							PKCS#1 v1.5 padding in HW can be globally disabled by option <code class="option">disable_hw_pkcs1_padding</code>.
+					</p><p>
+							PKCS#1 v1.5 padding in HW can be globally disabled by option <code class="literal">disable_hw_pkcs1_padding</code>.
 							When the global option is used to disable padding, the padding will be disabled even though the MyEID-specific option does not turn it off.
 					</p></dd></dl></div></div><div class="refsect2"><a name="npa"></a><h3>Configuration Options for German ID Card</h3><div class="variablelist"><dl class="variablelist"><dt><span class="term">
 						<code class="option">can = <em class="replaceable"><code>value</code></em>;</code>
@@ -533,14 +536,26 @@ app <em class="replaceable"><code>applic
 					</p></dd></dl></div></div><div class="refsect2"><a name="edo"></a><h3>Configuration Options for Polish eID Card</h3><div class="variablelist"><dl class="variablelist"><dt><span class="term">
 						<code class="option">can = <em class="replaceable"><code>value</code></em>;</code>
 					</span></dt><dd><p>
-							CAN (Card Access Number &#8211; 6 digit number
+							CAN (Card Access Number – 6 digit number
 							printed on the right bottom corner of the
 							front side of the document) is required
 							to establish connection with the card.
 							It might be overwritten by <code class="literal">EDO_CAN</code>
 							environment variable. Currently, it is not
 							possible to set it in any other way.
-					</p></dd></dl></div></div><div class="refsect2"><a name="card_atr"></a><h3>Configuration based on ATR</h3><p>
+					</p></dd></dl></div></div><div class="refsect2"><a name="eoi"></a><h3>Configuration Options for Slovenian eID Card</h3><div class="variablelist"><dl class="variablelist"><dt><span class="term">
+						<code class="option">can = <em class="replaceable"><code>value</code></em>;</code>
+					</span></dt><dd><p>
+							CAN (Card Access Number – 6 digit number
+							printed on the right bottom corner of the
+							front side of the document) is required
+							to establish connection with the card.
+							It might be overwritten by <code class="literal">EOI_CAN</code>
+							environment variable. As CAN is also stored on the card
+							(in encrypted form) it can be used to automatically establish
+							secure connection, but only if the card is accessed over the
+							contact interface.
+					</p></dd></dl></div></div><div class="refsect2"><a name="piv"></a><h3>Configuration Options for PIV Card</h3><div class="variablelist"><dl class="variablelist"></dl></div></div><div class="refsect2"><a name="card_atr"></a><h3>Configuration based on ATR</h3><p>
 				</p><div class="variablelist"><dl class="variablelist"><dt><span class="term">
 							<code class="option">atrmask = <em class="replaceable"><code>hexstring</code></em>;</code>
 						</span></dt><dd><p>
@@ -798,7 +813,6 @@ app <em class="replaceable"><code>applic
 							<code class="literal">jpki</code>,
 							<code class="literal">MaskTech</code>,
 							<code class="literal">mcrd</code>,
-							<code class="literal">MyEID</code>,
 							<code class="literal">npa</code>,
 							<code class="literal">nqapplet</code>,
 							<code class="literal">tcos</code> and otherwise <code class="literal">no</code>).
@@ -829,6 +843,15 @@ app <em class="replaceable"><code>applic
 							cached information. Note that the cached files
 							may contain personal data such as name and mail
 							address.
+						</p><p>
+                            The PIV-II card driver supports the history object's
+                            list of retired keys and certificates if they are
+							readable in the file cache directory.
+							If the specified object's URL is
+							<code class="literal">"http://"</code><em class="replaceable"><code>DNS name</code></em><code class="literal">"/"</code><em class="replaceable"><code>ASCII-HEX OffCardKeyHistoryFile</code></em>,
+							then the searches for the file name
+							<em class="replaceable"><code>OffCardKeyHistoryFile</code></em>
+							in the cache directory.
 					</p></dd><dt><span class="term">
 						<code class="option">use_pin_caching = <em class="replaceable"><code>bool</code></em>;</code>
 					</span></dt><dd><p>
@@ -960,6 +983,14 @@ app <em class="replaceable"><code>applic
 										Do not expose application in PKCS#15
 										framework (Default:
 										<code class="literal">false</code>)
+								</p></dd><dt><span class="term">
+									<code class="option">user_pin = <em class="replaceable"><code>name</code></em>;</code>
+								</span></dt><dd><p>
+									Name of the User PIN object that will be used as the main PIN.
+								</p></dd><dt><span class="term">
+									<code class="option">sign_pin = <em class="replaceable"><code>name</code></em>;</code>
+								</span></dt><dd><p>
+									Name of the PIN object that will be used for signing.
 								</p></dd></dl></div></dd></dl></div></div><div class="refsect2"><a name="framework%20tokend"></a><h3>Configuration of Tokend</h3><div class="variablelist"><dl class="variablelist"><dt><span class="term">
 						<code class="option">score = <em class="replaceable"><code>num</code></em>;</code>
 					</span></dt><dd><p>
@@ -976,10 +1007,13 @@ app <em class="replaceable"><code>applic
 					</p></dd><dt><span class="term">
 						<code class="option">slots_per_card = <em class="replaceable"><code>num</code></em>;</code>
 					</span></dt><dd><p>
-							Maximum number of slots per smart card (Default:
-							<code class="literal">4</code>).  If the card has fewer keys
+							Maximum number of PIN slots per smart card (Default:
+							<code class="literal">4</code>).  If the card has fewer PINs
 							than defined here, the remaining number of slots
-							will be empty.
+                            will be empty. For Firefox, Chrome and Chromium, the
+							<code class="option">slots_per_card</code> is set to <code class="literal">1</code>,
+							to avoid prompting for unrelated PINs.  Typically, this
+							effectively disables signature PINs and keys.
 					</p></dd><dt><span class="term">
 						<code class="option">lock_login = <em class="replaceable"><code>bool</code></em>;</code>
 					</span></dt><dd><p>
@@ -1168,15 +1202,21 @@ app <em class="replaceable"><code>applic
 				</span></dt><dd><p>
 						PIV configuration during initialization with
 						<span class="application">piv-tool</span>.
+				</p></dd><dt><span class="term">
+					<code class="envar">PIV_USE_SM</code>,
+					<code class="envar">PIV_PAIRING_CODE</code>
+				</span></dt><dd><p>
+						PIV configuration during initialization
+						See Configuration Options for PIV Card.
 				</p></dd></dl></div></div><div class="refsect1"><a name="id-1.2.6"></a><h2>Files</h2><div class="variablelist"><dl class="variablelist"><dt><span class="term">
-					<code class="filename">/usr/etc/opensc.conf</code>
+					<code class="filename">/etc/opensc.conf</code>
 				</span></dt><dd><p>
 						System-wide configuration file
 				</p></dd><dt><span class="term">
 					<code class="filename">/usr/share/doc/opensc/opensc.conf</code>
 				</span></dt><dd><p>
 						Extended example configuration file
-				</p></dd></dl></div></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="pkcs15-profile"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>pkcs15-profile &#8212; format of profile for <span class="command"><strong>pkcs15-init</strong></span></p></div><div class="refsect1"><a name="id-1.3.3"></a><h2>Description</h2><p>
+				</p></dd></dl></div></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="pkcs15-profile"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>pkcs15-profile — format of profile for <span class="command"><strong>pkcs15-init</strong></span></p></div><div class="refsect1"><a name="id-1.3.3"></a><h2>Description</h2><p>
 			The <span class="command"><strong>pkcs15-init</strong></span> utility for PKCS #15 smart card
 			personalization is controlled via profiles. When starting, it will read two
 			such profiles at the moment, a generic application profile, and a card
diff -pruN 0.25.0~rc1-1/doc/files/opensc.conf.5.xml.in 0.25.1-1/doc/files/opensc.conf.5.xml.in
--- 0.25.0~rc1-1/doc/files/opensc.conf.5.xml.in	2024-02-17 23:32:31.000000000 +0000
+++ 0.25.1-1/doc/files/opensc.conf.5.xml.in	2024-04-04 14:21:38.000000000 +0000
@@ -154,7 +154,7 @@ app <replaceable>application</replaceabl
 				</term>
 				<listitem><para>
 						PKCS#15 initialization/personalization profiles
-						directory for 
+						directory for
 						<citerefentry>
 							<refentrytitle>pkcs15-init</refentrytitle>
 							<manvolnum>1</manvolnum>.
@@ -1306,8 +1306,8 @@ app <replaceable>application</replaceabl
 						<para>
                             The PIV-II card driver supports the history object's
                             list of retired keys and certificates if they are
-							readable in the file cache directory. 
-							If the specified object's URL is 
+							readable in the file cache directory.
+							If the specified object's URL is
 							<literal>"http://"</literal><replaceable>DNS name</replaceable><literal>"/"</literal><replaceable>ASCII-HEX OffCardKeyHistoryFile</replaceable>,
 							then the searches for the file name
 							<replaceable>OffCardKeyHistoryFile</replaceable>
diff -pruN 0.25.0~rc1-1/doc/html.xsl 0.25.1-1/doc/html.xsl
--- 0.25.0~rc1-1/doc/html.xsl	2024-02-17 23:32:31.000000000 +0000
+++ 0.25.1-1/doc/html.xsl	2024-04-04 14:21:38.000000000 +0000
@@ -3,7 +3,7 @@
 <!ENTITY css SYSTEM "api.css">
 ]>
 <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
-	<xsl:import href="docbook.xsl"/>
+	<xsl:import href="docbook-utf8.xsl"/>
 	<xsl:param name="toc.section.depth" select="0"/>
 	<xsl:param name="generate.consistent.ids" select="1"/>
 	<xsl:template name="user.head.content">
diff -pruN 0.25.0~rc1-1/doc/tools/dnie-tool.1.xml 0.25.1-1/doc/tools/dnie-tool.1.xml
--- 0.25.0~rc1-1/doc/tools/dnie-tool.1.xml	2024-02-17 23:32:31.000000000 +0000
+++ 0.25.1-1/doc/tools/dnie-tool.1.xml	2024-04-04 14:21:38.000000000 +0000
@@ -12,7 +12,7 @@
 		<refname>dnie-tool</refname>
 		<refpurpose>displays information about DNIe based security tokens</refpurpose>
 	</refnamediv>
-	
+
 	<refsynopsisdiv>
 		<cmdsynopsis>
 			<command>dnie-tool</command>
@@ -109,7 +109,7 @@
 				</varlistentry>
 				<varlistentry>
 					<term>
-						<option>--wait</option>, 
+						<option>--wait</option>,
 						<option>-w</option>
 					</term>
 					<listitem><para>Causes <command>dnie-tool</command> to wait for the token to be inserted into reader.</para>
@@ -120,14 +120,14 @@
 						<option>--verbose</option>,
 						<option>-v</option>
 					</term>
-					<listitem><para>Causes <command>dnie-tool</command> to be more verbose. 
+					<listitem><para>Causes <command>dnie-tool</command> to be more verbose.
 					Specify this flag several times
 to enable debug output in the opensc library.</para></listitem>
 				</varlistentry>
 			</variablelist>
 		</para>
 	</refsect1>
-	
+
 	<refsect1>
 		<title>Authors</title>
 		<para><command>dnie-tool</command> was written by
diff -pruN 0.25.0~rc1-1/doc/tools/dtrust-tool.1.xml 0.25.1-1/doc/tools/dtrust-tool.1.xml
--- 0.25.0~rc1-1/doc/tools/dtrust-tool.1.xml	1970-01-01 00:00:00.000000000 +0000
+++ 0.25.1-1/doc/tools/dtrust-tool.1.xml	2024-04-04 14:21:38.000000000 +0000
@@ -0,0 +1,137 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<refentry id="dtrust-tool">
+	<refmeta>
+		<refentrytitle>dtrust-tool</refentrytitle>
+		<manvolnum>1</manvolnum>
+		<refmiscinfo class="productname">OpenSC</refmiscinfo>
+		<refmiscinfo class="manual">OpenSC Tools</refmiscinfo>
+		<refmiscinfo class="source">opensc</refmiscinfo>
+	</refmeta>
+
+	<refnamediv>
+		<refname>dtrust-tool</refname>
+		<refpurpose>
+			displays information about D-Trust signature cards and remove the transport protection
+		</refpurpose>
+	</refnamediv>
+
+	<refsynopsisdiv>
+		<cmdsynopsis>
+			<command>dtrust-tool</command>
+			<arg choice="opt"><replaceable class="option">OPTIONS</replaceable></arg>
+		</cmdsynopsis>
+	</refsynopsisdiv>
+
+	<refsect1>
+		<title>Description</title>
+		<para>
+			The <command>dtrust-tool</command> utility is used to display information about
+			D-Trust signature cards and to remove the initial transport protection.
+		</para>
+	</refsect1>
+
+	<refsect1>
+		<title>Options</title>
+		<para>
+			<variablelist>
+				<varlistentry>
+					<term>
+						<option>--check-transport-protection</option>,
+						<option>-c</option>
+					</term>
+					<listitem>
+						<para>
+							In the delivery state the card is locked by a so called
+							transport protection. This option allows to check if the
+							transport protection is still in force. The Signature PIN can
+							only be used if the transport protection is removed.
+						</para>
+
+						<para>
+							Initially the transport protection should be intact. If you
+							receive a new card and the transport protection was already
+							broken, don't use that card and contact the producer for
+							further advice.
+						</para>
+
+						<para>
+							If you removed the transport protection, it is normal that
+							<command>dtrust-tool</command> reports the transport protection
+							as broken. This is the normal operation state. It does not mean
+							your card is broken.
+						</para>
+					</listitem>
+				</varlistentry>
+				<varlistentry>
+					<term>
+						<option>--help</option>,
+						<option>-h</option>
+					</term>
+					<listitem><para>Print help message on screen.</para></listitem>
+				</varlistentry>
+				<varlistentry>
+					<term>
+						<option>--reader</option> <replaceable>arg</replaceable>,
+						<option>-r</option> <replaceable>arg</replaceable>
+					</term>
+					<listitem><para>
+						Number of the reader to use. By default, the first reader with a
+						present card is used. If <replaceable>arg</replaceable> is an ATR, the
+						reader with a matching card will be chosen.
+					</para></listitem>
+				</varlistentry>
+				<varlistentry>
+					<term>
+						<option>--pin-status</option>,
+						<option>-s</option>
+					</term>
+					<listitem><para>
+						Show the status of the various PINs. The Card Holder PIN is used for
+						advanced signatures and decryption. It is only defined for signature
+						cards, but not for sealing cards. The signature PIN is used for
+						qualified signatures. It can only be used if it is unlocked by
+						presenting the Transport PIN. Once the Transport PIN is used, it cannot
+						be used anymore. The PUK is used to unlock PIN which had beend entered
+						incorrectly several times.
+					</para></listitem>
+				</varlistentry>
+				<varlistentry>
+					<term>
+						<option>--unlock-transport-protection</option>,
+						<option>-u</option>
+					</term>
+					<listitem><para>
+						This command removes the transport protection. If first queries for the
+						Transport PIN and then for the new value of the Signature PIN twice.
+					</para></listitem>
+				</varlistentry>
+				<varlistentry>
+					<term>
+						<option>--verbose</option>,
+						<option>-v</option>
+					</term>
+					<listitem><para>
+						Causes <command>dtrust-tool</command> to be more verbose. Specify this
+						flag several times to enable debug output in the opensc library.
+					</para></listitem>
+				</varlistentry>
+				<varlistentry>
+					<term>
+						<option>--wait</option>,
+						<option>-w</option>
+					</term>
+					<listitem><para>
+						Causes <command>dtrust-tool</command> to wait for the token to be
+						inserted into reader.
+					</para></listitem>
+				</varlistentry>
+			</variablelist>
+		</para>
+	</refsect1>
+
+	<refsect1>
+		<title>Authors</title>
+		<para><command>dtrust-tool</command> was written by
+		Mario Haustein <email>mario.haustein@hrz.tu-chemnitz.de</email>.</para>
+	</refsect1>
+</refentry>
diff -pruN 0.25.0~rc1-1/doc/tools/npa-tool.1.xml 0.25.1-1/doc/tools/npa-tool.1.xml
--- 0.25.0~rc1-1/doc/tools/npa-tool.1.xml	2024-02-17 23:32:31.000000000 +0000
+++ 0.25.1-1/doc/tools/npa-tool.1.xml	2024-04-04 14:21:38.000000000 +0000
@@ -218,7 +218,7 @@
 				<varlistentry>
 					<term><option>--cvc-dir</option> <replaceable>DIRECTORY</replaceable></term>
 					<listitem><para>
-						Specify where to look for the certificate of the 
+						Specify where to look for the certificate of the
 						Country Verifying Certification Authority
 						(<abbrev>CVCA</abbrev>).
 						If not given, it defaults to
diff -pruN 0.25.0~rc1-1/doc/tools/pkcs11-tool.1.xml 0.25.1-1/doc/tools/pkcs11-tool.1.xml
--- 0.25.0~rc1-1/doc/tools/pkcs11-tool.1.xml	2024-02-17 23:32:31.000000000 +0000
+++ 0.25.1-1/doc/tools/pkcs11-tool.1.xml	2024-04-04 14:21:38.000000000 +0000
@@ -707,19 +707,22 @@
 	<refsect1>
 		<title>Examples</title>
 		<para>
-			To list all certificates on the smart card:
+			Perform a basic functionality test of the card:
+				<programlisting>pkcs11-tool --test --login</programlisting>
+
+			List all certificates on the smart card:
 				<programlisting>pkcs11-tool --list-objects --type cert</programlisting>
 
-			To read the certificate with ID <replaceable>KEY_ID</replaceable>
-			in DER format from smart card:
-				<programlisting>pkcs11-tool --read-object --id KEY_ID --type cert --output-file cert.der</programlisting>
-
-			Write certificate to token:
-				<programlisting> pkcs11-tool --login --write-object certificate.der --type cert</programlisting>
-
-			To convert the certificate in DER format to PEM format, use OpenSSL
-			tools:
-				<programlisting>openssl x509 -inform DER -in cert.der -outform PEM > cert.pem</programlisting>
+			Read the certificate with ID <varname>CERT_ID</varname>
+			in DER format from smart card and convert it to PEM via OpenSSL:
+			<programlisting>
+pkcs11-tool --read-object --id $CERT_ID --type cert \
+					--output-file cert.der
+openssl x509 -inform DER -in cert.der -outform PEM > cert.pem
+			</programlisting>
+
+			Write a certificate to token:
+				<programlisting>pkcs11-tool --login --write-object certificate.der --type cert</programlisting>
 
 			Generate new RSA Key pair:
 				<programlisting>pkcs11-tool --login --keypairgen --key-type RSA:2048</programlisting>
@@ -727,41 +730,71 @@
 			Generate new extractable RSA Key pair:
 				<programlisting>pkcs11-tool --login --keypairgen --key-type RSA:2048 --extractable</programlisting>
 
+			Generate an elliptic curve key pair with OpenSSL and import it to the card as <varname>$ID</varname>:
+				<programlisting>openssl genpkey -out EC_private.der -outform DER \
+	-algorithm EC -pkeyopt ec_paramgen_curve:P-521
+pkcs11-tool --write-object EC_private.der --id "$ID" \
+	--type privkey --label "EC private key" -p "$PIN"
+openssl pkey -in EC_private.der -out EC_public.der \
+	-pubout -inform DER -outform DER
+pkcs11-tool --write-object EC_public.der --id "$ID" \
+	--type pubkey  --label "EC public key" -p $PIN</programlisting>
+
 			List private keys:
 				<programlisting>pkcs11-tool --login --list-objects --type privkey</programlisting>
 
-			To sign some data stored in file <replaceable>data</replaceable>
-			using the private key with ID <replaceable>ID</replaceable> and
+			Sign some data stored in file <filename>data</filename>
+			using the private key with ID <varname>ID</varname> and
 			using the RSA-PKCS mechanism:
-				<programlisting>pkcs11-tool --sign --id ID --mechanism RSA-PKCS --input-file data --output-file data.sig</programlisting>
+			<programlisting>
+pkcs11-tool --sign --id $ID --mechanism RSA-PKCS \
+	--input-file data --output-file data.sig
+			</programlisting>
 			The same is also possible by piping the data from stdin rather than specifying a input file:
-				<programlisting>dd if=data bs=128 count=1 | pkcs11-tool --sign --id ID --mechanism RSA-PKCS --pin=$PIN > data.sig</programlisting>
+			<programlisting>
+dd if=data bs=128 count=1 \
+	| pkcs11-tool --sign --id $ID --mechanism RSA-PKCS \
+	> data.sig
+			</programlisting>
+
+			Verify the signed data:
+			<programlisting>
+pkcs11-tool --id ID --verify -m RSA-PKCS \
+	--input-file data --signature-file data.sig
+			</programlisting>
 
 			To encrypt file using the AES key with ID 85 and using mechanism AES-CBC with padding:
 				<programlisting>
 pkcs11-tool --login --encrypt --id 85 -m AES-CBC-PAD \
- --iv "00000000000000000000000000000000" \
- -i file.txt -o encrypted_file.data
+	--iv "00000000000000000000000000000000" \
+	-i file.txt -o encrypted_file.data
 				</programlisting>
+			Decipher the encrypted file:
+				<programlisting>
+pkcs11-tool --login --decrypt --id 85 -m AES-CBC-PAD \
+	--iv "00000000000000000000000000000000" \
+	--i encrypted_file.data -o decrypted.txt
+				</programlisting>
+
 			Use the key with ID 75 using mechanism AES-CBC-PAD, with initialization vector
 			"00000000000000000000000000000000" to wrap the key with ID 76 into output file
-			<replaceable>exported_aes.key</replaceable>
+			<filename>exported_aes.key</filename>
 				<programlisting>
 pkcs11-tool --login --wrap --id 75 --mechanism AES-CBC-PAD \
- --iv "00000000000000000000000000000000" \
- --application-id 76 \
- --output-file exported_aes.key
+	--iv "00000000000000000000000000000000" \
+	--application-id 76 \
+	--output-file exported_aes.key
 				</programlisting>
 			Use the key with ID 22 and mechanism RSA-PKCS to unwrap key from file
-			<replaceable>aes_wrapped.key</replaceable>. After a successful unwrap operation,
+			<filename>aes_wrapped.key</filename>. After a successful unwrap operation,
 			a new AES key is created on token. ID of this key is set to 90 and label of this
-			key is set to <replaceable>unwrapped-key</replaceable>
+			key is set to <literal>unwrapped-key</literal>
 			Note: for the MyEID card, the AES key size must be present in key
 			specification i.e. AES:16
 				<programlisting>
 pkcs11-tool --login --unwrap --mechanism RSA-PKCS --id 22 \
-  -i aes_wrapped.key --key-type AES: \
-  --application-id 90 --applicatin-label unwrapped-key
+	-i aes_wrapped.key --key-type AES: \
+	--application-id 90 --applicatin-label unwrapped-key
 				</programlisting>
 
 			Use the SO-PIN to initialize or re-set the PIN:
diff -pruN 0.25.0~rc1-1/doc/tools/pkcs15-init.1.xml 0.25.1-1/doc/tools/pkcs15-init.1.xml
--- 0.25.0~rc1-1/doc/tools/pkcs15-init.1.xml	2024-02-17 23:32:31.000000000 +0000
+++ 0.25.1-1/doc/tools/pkcs15-init.1.xml	2024-04-04 14:21:38.000000000 +0000
@@ -668,6 +668,18 @@
 
 				<varlistentry>
 					<term>
+						<option>--auth-id</option> <replaceable>filename</replaceable>,
+						<option>-a</option> <replaceable>filename</replaceable>
+					</term>
+					<listitem>
+						<para>
+							Specify ID of PIN to use/create
+						</para>
+					</listitem>
+				</varlistentry>
+
+				<varlistentry>
+					<term>
 						<option>--puk-id</option> <replaceable>ID</replaceable>
 					</term>
 					<listitem>
diff -pruN 0.25.0~rc1-1/doc/tools/sc-hsm-tool.1.xml 0.25.1-1/doc/tools/sc-hsm-tool.1.xml
--- 0.25.0~rc1-1/doc/tools/sc-hsm-tool.1.xml	2024-02-17 23:32:31.000000000 +0000
+++ 0.25.1-1/doc/tools/sc-hsm-tool.1.xml	2024-04-04 14:21:38.000000000 +0000
@@ -62,10 +62,10 @@
 						<para>Use <option>--pwd-shares-threshold</option> and <option>--pwd-shares-total</option> to randomly generate a password and split is using a (t, n) threshold scheme.</para>
 					</listitem>
 				</varlistentry>
-				
+
 				<varlistentry>
 					<term>
-						<option>--import-dkek-share</option> <replaceable>filename</replaceable>, 
+						<option>--import-dkek-share</option> <replaceable>filename</replaceable>,
 						<option>-I</option> <replaceable>filename</replaceable>
 					</term>
 					<listitem>
@@ -74,10 +74,10 @@
 						<para>Use <option>--pwd-shares-total</option> to specify the number of shares that should be entered to reconstruct the password.</para>
 					</listitem>
 				</varlistentry>
-				
+
 				<varlistentry>
 					<term>
-						<option>--wrap-key</option> <replaceable>filename</replaceable>, 
+						<option>--wrap-key</option> <replaceable>filename</replaceable>,
 						<option>-W</option> <replaceable>filename</replaceable>
 					</term>
 					<listitem>
@@ -86,39 +86,39 @@
 						<para>Use <option>--pin</option> to provide the user PIN on the command line.</para>
 					</listitem>
 				</varlistentry>
-				
+
 				<varlistentry>
 					<term>
-						<option>--unwrap-key</option> <replaceable>filename</replaceable>, 
+						<option>--unwrap-key</option> <replaceable>filename</replaceable>,
 						<option>-U</option> <replaceable>filename</replaceable>
 					</term>
 					<listitem>
 						<para>Read wrapped key, description and certificate from file and import into SmartCard-HSM
 						     under the key reference given in <option>--key-reference</option>.</para>
-						<para>Determine the key reference using the output of <command>pkcs15-tool -D</command>.</para>				     
+						<para>Determine the key reference using the output of <command>pkcs15-tool -D</command>.</para>
 						<para>Use <option>--pin</option> to provide a user PIN on the command line.</para>
 						<para>Use <option>--force</option> to remove any key, key description or certificate in the way.</para>
 					</listitem>
 				</varlistentry>
-				
+
 				<varlistentry>
 					<term>
-						<option>--dkek-shares</option> <replaceable>number-of-shares</replaceable>, 
+						<option>--dkek-shares</option> <replaceable>number-of-shares</replaceable>,
 						<option>-s</option> <replaceable>number-of-shares</replaceable>
 					</term>
 					<listitem>
 						<para>Define the number of DKEK shares to use for recreating the DKEK.</para>
-						<para>This is an optional parameter. Using <option>--initialize</option> without 
-						      <option>--dkek-shares</option> will disable the DKEK completely.</para>				     
+						<para>This is an optional parameter. Using <option>--initialize</option> without
+						      <option>--dkek-shares</option> will disable the DKEK completely.</para>
 						<para>Using <option>--dkek-shares</option> with 0 shares requests the SmartCard-HSM to
 						      generate a random DKEK. Keys wrapped with this DKEK can only be unwrapped in the
-						      same SmartCard-HSM.</para>		
+						      same SmartCard-HSM.</para>
 						<para>After using <option>--initialize</option> with one or more DKEK shares, the
 						      SmartCard-HSM will remain in the initialized state until all DKEK shares have
-						      been imported. During this phase no new keys can be generated or imported.</para>		     
+						      been imported. During this phase no new keys can be generated or imported.</para>
 					</listitem>
 				</varlistentry>
-				
+
 				<varlistentry>
 					<term>
 						<option>--pin</option> <replaceable>pin</replaceable>,
@@ -142,7 +142,7 @@
 						</para>
 					</listitem>
 				</varlistentry>
-				
+
 				<varlistentry>
 					<term>
 						<option>--pin-retry</option> <replaceable>value</replaceable>
@@ -181,7 +181,7 @@
 						<replaceable>VARIABLE</replaceable> is used.</para>
 					</listitem>
 				</varlistentry>
-				
+
 				<varlistentry>
 					<term>
 						<option>--pwd-shares-threshold</option> <replaceable>value</replaceable>
@@ -190,7 +190,7 @@
 						<para>Define threshold for number of password shares required for reconstruction.</para>
 					</listitem>
 				</varlistentry>
-				
+
 				<varlistentry>
 					<term>
 						<option>--pwd-shares-total</option> <replaceable>value</replaceable>
@@ -199,7 +199,7 @@
 						<para>Define number of password shares.</para>
 					</listitem>
 				</varlistentry>
-				
+
 				<varlistentry>
 					<term>
 						<option>--force</option>
@@ -208,7 +208,7 @@
 						<para>Force removal of existing key, description and certificate.</para>
 					</listitem>
 				</varlistentry>
-				
+
 				<varlistentry>
 					<term>
 						<option>--label</option> <replaceable>label</replaceable>,
@@ -216,7 +216,7 @@
 					</term>
 					<listitem><para>Define the token label to be used in --initialize.</para></listitem>
 				</varlistentry>
-				
+
 				<varlistentry>
 					<term>
 						<option>--reader</option> <replaceable>arg</replaceable>,
@@ -299,7 +299,7 @@
 						</para>
 					</listitem>
 				</varlistentry>
-				
+
 				<varlistentry>
 					<term>
 						<option>--wait</option>,
@@ -307,7 +307,7 @@
 					</term>
 					<listitem><para>Wait for a card to be inserted</para></listitem>
 				</varlistentry>
-				
+
 				<varlistentry>
 					<term>
 						<option>--verbose</option>,
@@ -345,7 +345,7 @@
 		<para><command>sc-hsm-tool --register-public-key ./public_key1.asn1</command></para>
 
 	</refsect1>
-	
+
 	<refsect1>
 		<title>See also</title>
 		<para>
diff -pruN 0.25.0~rc1-1/doc/tools/tools.html 0.25.1-1/doc/tools/tools.html
--- 0.25.0~rc1-1/doc/tools/tools.html	2024-02-17 23:32:31.000000000 +0000
+++ 0.25.1-1/doc/tools/tools.html	2024-04-04 14:21:38.000000000 +0000
@@ -1,11 +1,11 @@
-<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>OpenSC Manual Pages: Section 1</title><meta name="generator" content="DocBook XSL Stylesheets V1.79.1"><style type="text/css"><!--
+<html><head><meta http-equiv="Content-Type" content="text/html; charset=UTF-8"><title>OpenSC Manual Pages: Section 1</title><meta name="generator" content="DocBook XSL Stylesheets Vsnapshot"><style type="text/css"><!--
 			body {
   font-family: Verdana, Arial;
   font-size: 0.9em;
 }
 
 .title {
-  font-size: 1.5em;
+  font-size: 1.5em; 
   text-align: center;
 }
 
@@ -43,20 +43,20 @@ span.errortext {
   font-style: italic;
 }
 
-		--></style></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book"><div class="titlepage"><div><div><h1 class="title"><a name="id-1"></a>OpenSC Manual Pages: Section 1</h1></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl class="toc"><dt><span class="refentrytitle"><a href="#cardos-tool">cardos-tool</a></span><span class="refpurpose"> &#8212; displays information about Card OS-based security tokens or format them
-		</span></dt><dt><span class="refentrytitle"><a href="#cryptoflex-tool">cryptoflex-tool</a></span><span class="refpurpose"> &#8212; utility for manipulating Schlumberger Cryptoflex data structures</span></dt><dt><span class="refentrytitle"><a href="#dnie-tool">dnie-tool</a></span><span class="refpurpose"> &#8212; displays information about DNIe based security tokens</span></dt><dt><span class="refentrytitle"><a href="#egk-tool">egk-tool</a></span><span class="refpurpose"> &#8212; displays information on the German electronic health card (elektronische Gesundheitskarte, <abbr class="abbrev">eGK</abbr>)
-		</span></dt><dt><span class="refentrytitle"><a href="#eidenv">eidenv</a></span><span class="refpurpose"> &#8212; utility for accessing visible data from
-		electronic identity cards</span></dt><dt><span class="refentrytitle"><a href="#gids-tool">gids-tool</a></span><span class="refpurpose"> &#8212; smart card utility for GIDS cards</span></dt><dt><span class="refentrytitle"><a href="#cardos-tool">iasecc-tool</a></span><span class="refpurpose"> &#8212; displays information about IAS/ECC card
-		</span></dt><dt><span class="refentrytitle"><a href="#netkey-tool">netkey-tool</a></span><span class="refpurpose"> &#8212; administrative utility for Netkey E4 cards</span></dt><dt><span class="refentrytitle"><a href="#npa-tool">npa-tool</a></span><span class="refpurpose"> &#8212; displays information on the German eID card (neuer Personalausweis, <abbr class="abbrev">nPA</abbr>).
-		</span></dt><dt><span class="refentrytitle"><a href="#openpgp-tool">openpgp-tool</a></span><span class="refpurpose"> &#8212; utility for accessing visible data OpenPGP smart cards
-		and compatible tokens</span></dt><dt><span class="refentrytitle"><a href="#opensc-asn1">opensc-asn1</a></span><span class="refpurpose"> &#8212; parse ASN.1 data
-		</span></dt><dt><span class="refentrytitle"><a href="#opensc-explorer">opensc-explorer</a></span><span class="refpurpose"> &#8212;
+		--></style></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book"><div class="titlepage"><div><div><h1 class="title"><a name="id-1"></a>OpenSC Manual Pages: Section 1</h1></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl class="toc"><dt><span class="refentrytitle"><a href="#cardos-tool">cardos-tool</a></span><span class="refpurpose"> — displays information about Card OS-based security tokens or format them
+		</span></dt><dt><span class="refentrytitle"><a href="#cryptoflex-tool">cryptoflex-tool</a></span><span class="refpurpose"> — utility for manipulating Schlumberger Cryptoflex data structures</span></dt><dt><span class="refentrytitle"><a href="#dnie-tool">dnie-tool</a></span><span class="refpurpose"> — displays information about DNIe based security tokens</span></dt><dt><span class="refentrytitle"><a href="#egk-tool">egk-tool</a></span><span class="refpurpose"> — displays information on the German electronic health card (elektronische Gesundheitskarte, <abbr class="abbrev">eGK</abbr>)
+		</span></dt><dt><span class="refentrytitle"><a href="#eidenv">eidenv</a></span><span class="refpurpose"> — utility for accessing visible data from
+		electronic identity cards</span></dt><dt><span class="refentrytitle"><a href="#gids-tool">gids-tool</a></span><span class="refpurpose"> — smart card utility for GIDS cards</span></dt><dt><span class="refentrytitle"><a href="#cardos-tool">iasecc-tool</a></span><span class="refpurpose"> — displays information about IAS/ECC card
+		</span></dt><dt><span class="refentrytitle"><a href="#netkey-tool">netkey-tool</a></span><span class="refpurpose"> — administrative utility for Netkey E4 cards</span></dt><dt><span class="refentrytitle"><a href="#npa-tool">npa-tool</a></span><span class="refpurpose"> — displays information on the German eID card (neuer Personalausweis, <abbr class="abbrev">nPA</abbr>).
+		</span></dt><dt><span class="refentrytitle"><a href="#openpgp-tool">openpgp-tool</a></span><span class="refpurpose"> — utility for accessing visible data OpenPGP smart cards
+		and compatible tokens</span></dt><dt><span class="refentrytitle"><a href="#opensc-asn1">opensc-asn1</a></span><span class="refpurpose"> — parse ASN.1 data
+		</span></dt><dt><span class="refentrytitle"><a href="#opensc-explorer">opensc-explorer</a></span><span class="refpurpose"> — 
 			generic interactive utility for accessing smart card
 			and similar security token functions
-		</span></dt><dt><span class="refentrytitle"><a href="#opensc-notify">opensc-notify</a></span><span class="refpurpose"> &#8212;  monitor smart card events and send notifications
-		</span></dt><dt><span class="refentrytitle"><a href="#opensc-tool">opensc-tool</a></span><span class="refpurpose"> &#8212; generic smart card utility</span></dt><dt><span class="refentrytitle"><a href="#piv-tool">piv-tool</a></span><span class="refpurpose"> &#8212; smart card utility for HSPD-12 PIV cards</span></dt><dt><span class="refentrytitle"><a href="#pkcs11-tool">pkcs11-tool</a></span><span class="refpurpose"> &#8212; utility for managing and using PKCS #11 security tokens</span></dt><dt><span class="refentrytitle"><a href="#pkcs15-crypt">pkcs15-crypt</a></span><span class="refpurpose"> &#8212; perform crypto operations using PKCS#15 smart cards</span></dt><dt><span class="refentrytitle"><a href="#pkcs15-init">pkcs15-init</a></span><span class="refpurpose"> &#8212; smart card personalization utility</span></dt><dt><span class="refentrytitle"><a href="#pkcs15-tool">pkcs15-tool</a></span><span class="refpurpose"> &#8212; utility for manipulating PKCS #15 data structures
-		on smart cards and similar security tokens</span></dt><dt><span class="refentrytitle"><a href="#sc-hsm-tool">sc-hsm-tool</a></span><span class="refpurpose"> &#8212; smart card utility for SmartCard-HSM</span></dt><dt><span class="refentrytitle"><a href="#westcos-tool">westcos-tool</a></span><span class="refpurpose"> &#8212; utility for manipulating data structures
-			on westcos smart cards</span></dt></dl></div><div class="refentry"><a name="cardos-tool"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>cardos-tool &#8212; displays information about Card OS-based security tokens or format them
+		</span></dt><dt><span class="refentrytitle"><a href="#opensc-notify">opensc-notify</a></span><span class="refpurpose"> —  monitor smart card events and send notifications
+		</span></dt><dt><span class="refentrytitle"><a href="#opensc-tool">opensc-tool</a></span><span class="refpurpose"> — generic smart card utility</span></dt><dt><span class="refentrytitle"><a href="#piv-tool">piv-tool</a></span><span class="refpurpose"> — smart card utility for HSPD-12 PIV cards</span></dt><dt><span class="refentrytitle"><a href="#pkcs11-tool">pkcs11-tool</a></span><span class="refpurpose"> — utility for managing and using PKCS #11 security tokens</span></dt><dt><span class="refentrytitle"><a href="#pkcs15-crypt">pkcs15-crypt</a></span><span class="refpurpose"> — perform crypto operations using PKCS#15 smart cards</span></dt><dt><span class="refentrytitle"><a href="#pkcs15-init">pkcs15-init</a></span><span class="refpurpose"> — smart card personalization utility</span></dt><dt><span class="refentrytitle"><a href="#pkcs15-tool">pkcs15-tool</a></span><span class="refpurpose"> — utility for manipulating PKCS #15 data structures
+		on smart cards and similar security tokens</span></dt><dt><span class="refentrytitle"><a href="#sc-hsm-tool">sc-hsm-tool</a></span><span class="refpurpose"> — smart card utility for SmartCard-HSM</span></dt><dt><span class="refentrytitle"><a href="#westcos-tool">westcos-tool</a></span><span class="refpurpose"> — utility for manipulating data structures
+			on westcos smart cards</span></dt></dl></div><div class="refentry"><a name="cardos-tool"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>cardos-tool — displays information about Card OS-based security tokens or format them
 		</p></div><div class="refsynopsisdiv"><h2>Synopsis</h2><div class="cmdsynopsis"><p><code class="command">cardos-tool</code>  [<em class="replaceable"><code>OPTIONS</code></em>]</p></div></div><div class="refsect1"><a name="id-1.2.4"></a><h2>Description</h2><p>
 			The <span class="command"><strong>cardos-tool</strong></span> utility is used to display information about
 smart cards and similar security tokens based on Siemens Card/OS M4.
@@ -94,7 +94,7 @@ smart cards and similar security tokens
 					</span></dt><dd><p>Causes <span class="command"><strong>cardos-tool</strong></span> to wait for the token
 					to be inserted into reader.</p></dd></dl></div><p>
 		</p></div><div class="refsect1"><a name="id-1.2.6"></a><h2>Authors</h2><p><span class="command"><strong>cardos-tool</strong></span> was written by
-		Andreas Jellinghaus <code class="email">&lt;<a class="email" href="mailto:aj@dungeon.inka.de">aj@dungeon.inka.de</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="cryptoflex-tool"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>cryptoflex-tool &#8212; utility for manipulating Schlumberger Cryptoflex data structures</p></div><div class="refsynopsisdiv"><h2>Synopsis</h2><div class="cmdsynopsis"><p><code class="command">cryptoflex-tool</code>  [<em class="replaceable"><code>OPTIONS</code></em>]</p></div></div><div class="refsect1"><a name="id-1.3.4"></a><h2>Description</h2><p>
+		Andreas Jellinghaus <code class="email">&lt;<a class="email" href="mailto:aj@dungeon.inka.de">aj@dungeon.inka.de</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="cryptoflex-tool"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>cryptoflex-tool — utility for manipulating Schlumberger Cryptoflex data structures</p></div><div class="refsynopsisdiv"><h2>Synopsis</h2><div class="cmdsynopsis"><p><code class="command">cryptoflex-tool</code>  [<em class="replaceable"><code>OPTIONS</code></em>]</p></div></div><div class="refsect1"><a name="id-1.3.4"></a><h2>Description</h2><p>
 			<span class="command"><strong>cryptoflex-tool</strong></span> is used to manipulate PKCS
 			data structures on Schlumberger Cryptoflex smart cards. Users
 			can create, list and read PINs and keys stored on the smart card.
@@ -164,7 +164,7 @@ smart cards and similar security tokens
 		</p></div><div class="refsect1"><a name="id-1.3.6"></a><h2>See also</h2><p>
 			<span class="citerefentry"><span class="refentrytitle">pkcs15-tool</span>(1)</span>
 		</p></div><div class="refsect1"><a name="id-1.3.7"></a><h2>Authors</h2><p><span class="command"><strong>cryptoflex-tool</strong></span> was written by
-		Juha Yrjölä <code class="email">&lt;<a class="email" href="mailto:juha.yrjola@iki.fi">juha.yrjola@iki.fi</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="dnie-tool"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>dnie-tool &#8212; displays information about DNIe based security tokens</p></div><div class="refsynopsisdiv"><h2>Synopsis</h2><div class="cmdsynopsis"><p><code class="command">dnie-tool</code>  [<em class="replaceable"><code>OPTIONS</code></em>]</p></div></div><div class="refsect1"><a name="id-1.4.4"></a><h2>Description</h2><p>
+		Juha Yrjölä <code class="email">&lt;<a class="email" href="mailto:juha.yrjola@iki.fi">juha.yrjola@iki.fi</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="dnie-tool"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>dnie-tool — displays information about DNIe based security tokens</p></div><div class="refsynopsisdiv"><h2>Synopsis</h2><div class="cmdsynopsis"><p><code class="command">dnie-tool</code>  [<em class="replaceable"><code>OPTIONS</code></em>]</p></div></div><div class="refsect1"><a name="id-1.4.4"></a><h2>Description</h2><p>
 			The <span class="command"><strong>dnie-tool</strong></span> utility is used to display additional information about DNIe, the Spanish National eID card.
 		</p></div><div class="refsect1"><a name="id-1.4.5"></a><h2>Options</h2><p>
 			</p><div class="variablelist"><dl class="variablelist"><dt><span class="term">
@@ -220,7 +220,7 @@ smart cards and similar security tokens
 					Specify this flag several times
 to enable debug output in the opensc library.</p></dd></dl></div><p>
 		</p></div><div class="refsect1"><a name="id-1.4.6"></a><h2>Authors</h2><p><span class="command"><strong>dnie-tool</strong></span> was written by
-		Juan Antonio Martinez <code class="email">&lt;<a class="email" href="mailto:jonsito@terra.es">jonsito@terra.es</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="egk-tool"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>egk-tool &#8212; displays information on the German electronic health card (elektronische Gesundheitskarte, <abbr class="abbrev">eGK</abbr>)
+		Juan Antonio Martinez <code class="email">&lt;<a class="email" href="mailto:jonsito@terra.es">jonsito@terra.es</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="egk-tool"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>egk-tool — displays information on the German electronic health card (elektronische Gesundheitskarte, <abbr class="abbrev">eGK</abbr>)
 		</p></div><div class="refsynopsisdiv"><h2>Synopsis</h2><div class="cmdsynopsis"><p><code class="command">egk-tool</code>  [<em class="replaceable"><code>OPTIONS</code></em>]</p></div></div><div class="refsect1"><a name="id-1.5.4"></a><h2>Description</h2><p>
 			The <span class="command"><strong>egk-tool</strong></span> utility is used to display information stored on the German elektronic health card (elektronische Gesundheitskarte, <abbr class="abbrev">eGK</abbr>).
 		</p></div><div class="refsect1"><a name="id-1.5.5"></a><h2>Options</h2><p>
@@ -243,16 +243,16 @@ to enable debug output in the opensc lib
 						Causes <span class="command"><strong>egk-tool</strong></span> to be more verbose.
 						Specify this flag several times to be more verbose.
 					</p></dd></dl></div><p>
-		</p><div class="refsect2"><a name="id-1.5.5.3"></a><h3>Health Care Application (<abbr class="abbrev">HCA</abbr>)</h3><div class="variablelist"><dl class="variablelist"><dt><span class="term"><code class="option">--pd</code></span></dt><dd><p>
-						Show 'Persönliche Versicherungsdaten' (XML).
+		</p><div class="refsect2"><a name="id-1.5.5.3"></a><h3>'Gesundheitsanwendung', Health Care Application (<abbr class="abbrev">HCA</abbr>)</h3><div class="variablelist"><dl class="variablelist"><dt><span class="term"><code class="option">--pd</code></span></dt><dd><p>
+						Show 'Persönliche Versichertendaten' (XML).
 					</p></dd><dt><span class="term"><code class="option">--vd</code></span></dt><dd><p>
-						Show 'Allgemeine Versicherungsdaten' (XML).
+						Show 'Allgemeine Versichertendaten' (XML).
 					</p></dd><dt><span class="term"><code class="option">--gvd</code></span></dt><dd><p>
-						Show 'Geschützte Versicherungsdaten' (XML).
+						Show 'Geschützte Versichertendaten' (XML).
 					</p></dd><dt><span class="term"><code class="option">--vsd-status</code></span></dt><dd><p>
 						Show 'Versichertenstammdaten-Status'.
 					</p></dd></dl></div></div></div><div class="refsect1"><a name="id-1.5.6"></a><h2>Authors</h2><p><span class="command"><strong>egk-tool</strong></span> was written by
-		Frank Morgner <code class="email">&lt;<a class="email" href="mailto:frankmorgner@gmail.com">frankmorgner@gmail.com</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="eidenv"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>eidenv &#8212; utility for accessing visible data from
+		Frank Morgner <code class="email">&lt;<a class="email" href="mailto:frankmorgner@gmail.com">frankmorgner@gmail.com</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="eidenv"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>eidenv — utility for accessing visible data from
 		electronic identity cards</p></div><div class="refsynopsisdiv"><h2>Synopsis</h2><div class="cmdsynopsis"><p><code class="command">eidenv</code>  [<em class="replaceable"><code>OPTIONS</code></em>]</p></div></div><div class="refsect1"><a name="id-1.6.4"></a><h2>Description</h2><p>
 			The <span class="command"><strong>eidenv</strong></span> utility is used for
 			accessing data from electronic identity cards (like
@@ -294,7 +294,7 @@ to enable debug output in the opensc lib
 						<code class="option">-w</code>
 					</span></dt><dd><p>Wait for a card to be inserted</p></dd></dl></div><p>
 		</p></div><div class="refsect1"><a name="id-1.6.6"></a><h2>Authors</h2><p><span class="command"><strong>eidenv</strong></span> utility was written by
-		Stef Hoeben and Martin Paljak <code class="email">&lt;<a class="email" href="mailto:martin@martinpaljak.net">martin@martinpaljak.net</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="gids-tool"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>gids-tool &#8212; smart card utility for GIDS cards</p></div><div class="refsynopsisdiv"><h2>Synopsis</h2><div class="cmdsynopsis"><p><code class="command">gids-tool</code>  [<em class="replaceable"><code>OPTIONS</code></em>]</p></div></div><div class="refsect1"><a name="id-1.7.4"></a><p>
+		Stef Hoeben and Martin Paljak <code class="email">&lt;<a class="email" href="mailto:martin@martinpaljak.net">martin@martinpaljak.net</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="gids-tool"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>gids-tool — smart card utility for GIDS cards</p></div><div class="refsynopsisdiv"><h2>Synopsis</h2><div class="cmdsynopsis"><p><code class="command">gids-tool</code>  [<em class="replaceable"><code>OPTIONS</code></em>]</p></div></div><div class="refsect1"><a name="id-1.7.4"></a><p>
 			The <span class="command"><strong>gids-tool</strong></span> utility can be used from the command line to perform
 			miscellaneous smart card operations on a GIDS smart card.
 		</p></div><div class="refsect1"><a name="id-1.7.5"></a><h2>Options</h2><p>
@@ -348,7 +348,7 @@ to enable debug output in the opensc lib
 		</p></div><div class="refsect1"><a name="id-1.7.6"></a><h2>See also</h2><p>
 			<span class="citerefentry"><span class="refentrytitle">opensc-tool</span>(1)</span>
 		</p></div><div class="refsect1"><a name="id-1.7.7"></a><h2>Authors</h2><p><span class="command"><strong>gids-tool</strong></span> was written by
-		Vincent Le Toux <code class="email">&lt;<a class="email" href="mailto:vincent.letoux@mysmartlogon.com">vincent.letoux@mysmartlogon.com</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="cardos-tool"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>iasecc-tool &#8212; displays information about IAS/ECC card
+		Vincent Le Toux <code class="email">&lt;<a class="email" href="mailto:vincent.letoux@mysmartlogon.com">vincent.letoux@mysmartlogon.com</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="cardos-tool"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>iasecc-tool — displays information about IAS/ECC card
 		</p></div><div class="refsynopsisdiv"><h2>Synopsis</h2><div class="cmdsynopsis"><p><code class="command">iasecc-tool</code>  [<em class="replaceable"><code>OPTIONS</code></em>]</p></div></div><div class="refsect1"><a name="id-1.8.4"></a><h2>Description</h2><p>
 			The <span class="command"><strong>iasecc-tool</strong></span> utility is used to display information about IAS/ECC v1.0.1 smart cards.
 		</p></div><div class="refsect1"><a name="id-1.8.5"></a><h2>Options</h2><p>
@@ -376,7 +376,7 @@ to enable debug output in the opensc lib
 					</span></dt><dd><p>Causes <span class="command"><strong>iasecc-tool</strong></span> to wait for the token
 					to be inserted into reader.</p></dd></dl></div><p>
 		</p></div><div class="refsect1"><a name="id-1.8.6"></a><h2>Authors</h2><p><span class="command"><strong>iasecc-tool</strong></span> was written by
-		Viktor Tarasov <code class="email">&lt;<a class="email" href="mailto:viktor.tarasov@gmail.com">viktor.tarasov@gmail.com</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="netkey-tool"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>netkey-tool &#8212; administrative utility for Netkey E4 cards</p></div><div class="refsynopsisdiv"><h2>Synopsis</h2><div class="cmdsynopsis"><p><code class="command">netkey-tool</code>  [<em class="replaceable"><code>OPTIONS</code></em>] [<em class="replaceable"><code>COMMAND</code></em>]</p></div></div><div class="refsect1"><a name="id-1.9.4"></a><h2>Description</h2><p>The <span class="command"><strong>netkey-tool</strong></span> utility can be used from the
+		Viktor Tarasov <code class="email">&lt;<a class="email" href="mailto:viktor.tarasov@gmail.com">viktor.tarasov@gmail.com</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="netkey-tool"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>netkey-tool — administrative utility for Netkey E4 cards</p></div><div class="refsynopsisdiv"><h2>Synopsis</h2><div class="cmdsynopsis"><p><code class="command">netkey-tool</code>  [<em class="replaceable"><code>OPTIONS</code></em>] [<em class="replaceable"><code>COMMAND</code></em>]</p></div></div><div class="refsect1"><a name="id-1.9.4"></a><h2>Description</h2><p>The <span class="command"><strong>netkey-tool</strong></span> utility can be used from the
     command line to perform some smart card operations with NetKey E4 cards
     that cannot be done easily with other OpenSC-tools, such as changing local
     PINs, storing certificates into empty NetKey E4 cert-files or displaying
@@ -459,11 +459,15 @@ to enable debug output in the opensc lib
     </p></div><div class="refsect1"><a name="id-1.9.8"></a><h2>See also</h2><p>
       <span class="citerefentry"><span class="refentrytitle">opensc-explorer</span>(1)</span>
     </p></div><div class="refsect1"><a name="id-1.9.9"></a><h2>Authors</h2><p><span class="command"><strong>netkey-tool</strong></span> was written by
-    Peter Koch <code class="email">&lt;<a class="email" href="mailto:pk_opensc@web.de">pk_opensc@web.de</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="npa-tool"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>npa-tool &#8212; displays information on the German eID card (neuer Personalausweis, <abbr class="abbrev">nPA</abbr>).
+    Peter Koch <code class="email">&lt;<a class="email" href="mailto:pk_opensc@web.de">pk_opensc@web.de</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="npa-tool"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>npa-tool — displays information on the German eID card (neuer Personalausweis, <abbr class="abbrev">nPA</abbr>).
 		</p></div><div class="refsynopsisdiv"><h2>Synopsis</h2><div class="cmdsynopsis"><p><code class="command">npa-tool</code>  [<em class="replaceable"><code>OPTIONS</code></em>]</p></div></div><div class="refsect1"><a name="id-1.10.4"></a><h2>Description</h2><p>
 			The <span class="command"><strong>npa-tool</strong></span> utility is used to display information
 			stored on the German eID card (neuer Personalausweis, <abbr class="abbrev">nPA</abbr>),
 			and to perform some write and verification operations.
+		</p><p>
+			Extended Access Control version 2 is performed according to ICAO Doc
+			9303 or BSI TR-03110 so that other identity cards and machine
+			readable travel documents (MRTDs) may be read as well.
 		</p></div><div class="refsect1"><a name="id-1.10.5"></a><h2>Options</h2><p>
 			</p><div class="variablelist"><dl class="variablelist"><dt><span class="term">
 						<code class="option">--help</code>,
@@ -602,7 +606,7 @@ to enable debug output in the opensc lib
 					</p></dd><dt><span class="term"><code class="option">--disable-all-checks</code></span></dt><dd><p>
 						 Disable all checking of fly-by-data. (default=off)
 					</p></dd></dl></div></div></div><div class="refsect1"><a name="id-1.10.6"></a><h2>Authors</h2><p><span class="command"><strong>npa-tool</strong></span> was written by
-		Frank Morgner <code class="email">&lt;<a class="email" href="mailto:frankmorgner@gmail.com">frankmorgner@gmail.com</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="openpgp-tool"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>openpgp-tool &#8212; utility for accessing visible data OpenPGP smart cards
+		Frank Morgner <code class="email">&lt;<a class="email" href="mailto:frankmorgner@gmail.com">frankmorgner@gmail.com</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="openpgp-tool"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>openpgp-tool — utility for accessing visible data OpenPGP smart cards
 		and compatible tokens</p></div><div class="refsynopsisdiv"><h2>Synopsis</h2><div class="cmdsynopsis"><p><code class="command">openpgp-tool</code>  [<em class="replaceable"><code>OPTIONS</code></em>]</p></div></div><div class="refsect1"><a name="id-1.11.4"></a><h2>Description</h2><p>
 			The <span class="command"><strong>openpgp-tool</strong></span> utility is used for
 			accessing data from the OpenPGP v1.1 and v2.0 smart cards
@@ -733,7 +737,7 @@ to enable debug output in the opensc lib
 						Wait for a card to be inserted.
 					</p></dd></dl></div><p>
 		</p></div><div class="refsect1"><a name="id-1.11.6"></a><h2>Authors</h2><p><span class="command"><strong>openpgp-tool</strong></span> utility was written by
-		Peter Marschall <code class="email">&lt;<a class="email" href="mailto:peter@adpm.de">peter@adpm.de</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="opensc-asn1"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>opensc-asn1 &#8212; parse ASN.1 data
+		Peter Marschall <code class="email">&lt;<a class="email" href="mailto:peter@adpm.de">peter@adpm.de</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="opensc-asn1"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>opensc-asn1 — parse ASN.1 data
 		</p></div><div class="refsynopsisdiv"><h2>Synopsis</h2><div class="cmdsynopsis"><p><code class="command">opensc-asn1</code>  [<em class="replaceable"><code>OPTIONS</code></em>] [<em class="replaceable"><code>FILES</code></em>]</p></div></div><div class="refsect1"><a name="id-1.12.4"></a><h2>Description</h2><p>
 			The <span class="command"><strong>opensc-asn1</strong></span> utility is used to parse ASN.1 data.
 		</p></div><div class="refsect1"><a name="id-1.12.5"></a><h2>Options</h2><p>
@@ -743,7 +747,7 @@ to enable debug output in the opensc lib
 						<code class="option">--version</code>,
 						<code class="option">-V</code></span></dt><dd><p>Print version and exit.</p></dd></dl></div><p>
 		</p></div><div class="refsect1"><a name="id-1.12.6"></a><h2>Authors</h2><p><span class="command"><strong>opensc-asn1</strong></span> was written by
-		Frank Morgner <code class="email">&lt;<a class="email" href="mailto:frankmorgner@gmail.com">frankmorgner@gmail.com</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="opensc-explorer"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>opensc-explorer &#8212;
+		Frank Morgner <code class="email">&lt;<a class="email" href="mailto:frankmorgner@gmail.com">frankmorgner@gmail.com</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="opensc-explorer"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>opensc-explorer — 
 			generic interactive utility for accessing smart card
 			and similar security token functions
 		</p></div><div class="refsynopsisdiv"><h2>Synopsis</h2><div class="cmdsynopsis"><p><code class="command">opensc-explorer</code>  [<em class="replaceable"><code>OPTIONS</code></em>] [<em class="replaceable"><code>SCRIPT</code></em>]</p></div></div><div class="refsect1"><a name="id-1.13.4"></a><h2>Description</h2><p>
@@ -812,14 +816,14 @@ to enable debug output in the opensc lib
 			The following commands are supported:
 			</p><div class="variablelist"><dl class="variablelist"><dt><span class="term">
 						<span class="command"><strong>#</strong></span>
-						  <em class="replaceable"><code></code></em>...
+						  <em class="replaceable"><code></code></em>... 
 					</span></dt><dd><p>
 							Treat line as a comment.
 							Ignore anything until the end of the line introduced by
 							<code class="literal">#</code>.
 						</p></dd><dt><span class="term">
 						<span class="command"><strong>apdu</strong></span>
-						  <em class="replaceable"><code>data</code></em>...
+						  <em class="replaceable"><code>data</code></em>... 
 					</span></dt><dd><p>
 							Send a custom APDU command to the card.
 							<em class="replaceable"><code>data</code></em> is a series of
@@ -872,7 +876,7 @@ to enable debug output in the opensc lib
 							<em class="replaceable"><code>DF-name</code></em>.
 						</p></dd><dt><span class="term">
 						<span class="command"><strong>change</strong></span>
-						  <code class="literal">CHV</code><em class="replaceable"><code>pin-ref</code></em>
+						  <code class="literal">CHV</code><em class="replaceable"><code>pin-ref</code></em> 
 						 [
 							[<em class="replaceable"><code>old-pin</code></em>]
 							<em class="replaceable"><code>new-pin</code></em>
@@ -951,7 +955,7 @@ to enable debug output in the opensc lib
 							in double quotes (<code class="literal">"..."</code>).
 						</p></dd><dt><span class="term">
 						<span class="command"><strong>echo</strong></span>
-						  <em class="replaceable"><code>string</code></em>...
+						  <em class="replaceable"><code>string</code></em>... 
 					</span></dt><dd><p>
 							Print the <em class="replaceable"><code>string</code></em>s given.
 						</p></dd><dt><span class="term">
@@ -1207,7 +1211,7 @@ to enable debug output in the opensc lib
 		</p></div><div class="refsect1"><a name="id-1.13.7"></a><h2>See also</h2><p>
 			<span class="citerefentry"><span class="refentrytitle">opensc-tool</span>(1)</span>
 		</p></div><div class="refsect1"><a name="id-1.13.8"></a><h2>Authors</h2><p><span class="command"><strong>opensc-explorer</strong></span> was written by
-		Juha Yrjölä <code class="email">&lt;<a class="email" href="mailto:juha.yrjola@iki.fi">juha.yrjola@iki.fi</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="opensc-notify"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>opensc-notify &#8212;  monitor smart card events and send notifications
+		Juha Yrjölä <code class="email">&lt;<a class="email" href="mailto:juha.yrjola@iki.fi">juha.yrjola@iki.fi</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="opensc-notify"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>opensc-notify —  monitor smart card events and send notifications
 		</p></div><div class="refsynopsisdiv"><h2>Synopsis</h2><div class="cmdsynopsis"><p><code class="command">opensc-notify</code>  [<em class="replaceable"><code>OPTIONS</code></em>]</p></div></div><div class="refsect1"><a name="id-1.14.4"></a><h2>Description</h2><p>
 			The <span class="command"><strong>opensc-notify</strong></span> utility is used to
 			monitor smart card events and send the appropriate notification.
@@ -1252,7 +1256,7 @@ to enable debug output in the opensc lib
 						See <em class="parameter"><code>notify_pin_bad</code></em>
 						in <code class="filename">opensc.conf</code> (default=off).
 					</p></dd></dl></div></div></div><div class="refsect1"><a name="id-1.14.6"></a><h2>Authors</h2><p><span class="command"><strong>opensc-notify</strong></span> was written by
-		Frank Morgner <code class="email">&lt;<a class="email" href="mailto:frankmorgner@gmail.com">frankmorgner@gmail.com</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="opensc-tool"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>opensc-tool &#8212; generic smart card utility</p></div><div class="refsynopsisdiv"><h2>Synopsis</h2><div class="cmdsynopsis"><p><code class="command">opensc-tool</code>  [<em class="replaceable"><code>OPTIONS</code></em>]</p></div></div><div class="refsect1"><a name="id-1.15.4"></a><h2>Description</h2><p>
+		Frank Morgner <code class="email">&lt;<a class="email" href="mailto:frankmorgner@gmail.com">frankmorgner@gmail.com</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="opensc-tool"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>opensc-tool — generic smart card utility</p></div><div class="refsynopsisdiv"><h2>Synopsis</h2><div class="cmdsynopsis"><p><code class="command">opensc-tool</code>  [<em class="replaceable"><code>OPTIONS</code></em>]</p></div></div><div class="refsect1"><a name="id-1.15.4"></a><h2>Description</h2><p>
 			The <span class="command"><strong>opensc-tool</strong></span> utility can be used from the command line to perform
 			miscellaneous smart card operations such as getting the card ATR or
 			sending arbitrary APDU commands to a card.
@@ -1309,8 +1313,16 @@ to enable debug output in the opensc lib
 					but <code class="literal">warm</code> reset is also possible.</p></dd><dt><span class="term">
 						<code class="option">--send-apdu</code> <em class="replaceable"><code>apdu</code></em>,
 						<code class="option">-s</code> <em class="replaceable"><code>apdu</code></em>
-					</span></dt><dd><p>Sends an arbitrary APDU to the card in the format
-					<code class="code">AA:BB:CC:DD:EE:FF...</code>.</p></dd><dt><span class="term">
+					</span></dt><dd><p>
+							Sends an arbitrary APDU to the card in the format
+							<code class="code">AA:BB:CC:DD:EE:FF...</code>. Use this option
+							multiple times to send more than one APDU.
+						</p><p>
+                            The built-in card drivers may send additional APDUs
+                            for detection and initialization. To avoid this
+							behavior, you may additionally specify
+							<code class="option">--card-driver</code> <code class="literal">default</code>.
+						</p></dd><dt><span class="term">
 						<code class="option">--serial</code>
 					</span></dt><dd><p>Print the card serial number (normally the ICCSN).
 					Output is in hex byte format</p></dd><dt><span class="term">
@@ -1324,7 +1336,7 @@ to enable debug output in the opensc lib
 		</p></div><div class="refsect1"><a name="id-1.15.6"></a><h2>See also</h2><p>
 			<span class="citerefentry"><span class="refentrytitle">opensc-explorer</span>(1)</span>
 		</p></div><div class="refsect1"><a name="id-1.15.7"></a><h2>Authors</h2><p><span class="command"><strong>opensc-tool</strong></span> was written by
-		Juha Yrjölä <code class="email">&lt;<a class="email" href="mailto:juha.yrjola@iki.fi">juha.yrjola@iki.fi</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="piv-tool"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>piv-tool &#8212; smart card utility for HSPD-12 PIV cards</p></div><div class="refsynopsisdiv"><h2>Synopsis</h2><div class="cmdsynopsis"><p><code class="command">piv-tool</code>  [<em class="replaceable"><code>OPTIONS</code></em>]</p></div></div><div class="refsect1"><a name="id-1.16.4"></a><p>
+		Juha Yrjölä <code class="email">&lt;<a class="email" href="mailto:juha.yrjola@iki.fi">juha.yrjola@iki.fi</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="piv-tool"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>piv-tool — smart card utility for HSPD-12 PIV cards</p></div><div class="refsynopsisdiv"><h2>Synopsis</h2><div class="cmdsynopsis"><p><code class="command">piv-tool</code>  [<em class="replaceable"><code>OPTIONS</code></em>]</p></div></div><div class="refsect1"><a name="id-1.16.4"></a><p>
 			The <span class="command"><strong>piv-tool</strong></span> utility can be used from the command line to perform
 			miscellaneous smart card operations on a HSPD-12 PIV smart card as defined in NIST 800-73-3.
 			It is intended for use with test cards only. It can be used to load objects, and generate
@@ -1340,15 +1352,18 @@ to enable debug output in the opensc lib
 					</span></dt><dd><p>Print the name of the inserted card (driver)</p></dd><dt><span class="term">
 						<code class="option">--admin</code> <em class="replaceable"><code>argument</code></em>,
 						<code class="option">-A</code> <em class="replaceable"><code>argument</code></em>
-					</span></dt><dd><p>Authenticate to the card using a 2DES or 3DES key.
+					</span></dt><dd><p>Authenticate to the card using a 2DES, 3DES or AES key.
 					The <em class="replaceable"><code>argument</code></em> of the form
 					</p><pre class="synopsis"> {<code class="literal">A</code>|<code class="literal">M</code>}<code class="literal">:</code><em class="replaceable"><code>ref</code></em><code class="literal">:</code><em class="replaceable"><code>alg</code></em></pre><p>
 					is required, were <code class="literal">A</code> uses "EXTERNAL AUTHENTICATION"
 					and <code class="literal">M</code> uses "MUTUAL AUTHENTICATION".
 					<em class="replaceable"><code>ref</code></em> is normally <code class="literal">9B</code>,
-					and <em class="replaceable"><code>alg</code></em> is <code class="literal">03</code> for 3DES.
-					The key is provided by the card vendor, and the environment variable
-					<code class="varname">PIV_EXT_AUTH_KEY</code> must point to a text file containing
+					and <em class="replaceable"><code>alg</code></em> is <code class="literal">03</code> for 3DES,
+					<code class="literal">01</code> for 2DES, <code class="literal">08</code> for AES-128,
+					<code class="literal">0A</code> for AES-192 or <code class="literal">0C</code> for AES-256.
+					The key is provided by the card vendor. The environment variable
+					<code class="varname">PIV_EXT_AUTH_KEY</code> must point to either a binary file
+					matching the length of the key or a text file containing
 					the key in the format:
 					<code class="code">XX:XX:XX:XX:XX:XX:XX:XX:XX:XX:XX:XX:XX:XX:XX:XX:XX:XX:XX:XX:XX:XX:XX:XX</code>
 					</p></dd><dt><span class="term">
@@ -1415,7 +1430,7 @@ to enable debug output in the opensc lib
 		</p></div><div class="refsect1"><a name="id-1.16.6"></a><h2>See also</h2><p>
 			<span class="citerefentry"><span class="refentrytitle">opensc-tool</span>(1)</span>
 		</p></div><div class="refsect1"><a name="id-1.16.7"></a><h2>Authors</h2><p><span class="command"><strong>piv-tool</strong></span> was written by
-		Douglas E. Engert <code class="email">&lt;<a class="email" href="mailto:deengert@gmail.com">deengert@gmail.com</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="pkcs11-tool"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>pkcs11-tool &#8212; utility for managing and using PKCS #11 security tokens</p></div><div class="refsynopsisdiv"><h2>Synopsis</h2><div class="cmdsynopsis"><p><code class="command">pkcs11-tool</code>  [<em class="replaceable"><code>OPTIONS</code></em>]</p></div></div><div class="refsect1"><a name="id-1.17.4"></a><h2>Description</h2><p>
+		Douglas E. Engert <code class="email">&lt;<a class="email" href="mailto:deengert@gmail.com">deengert@gmail.com</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="pkcs11-tool"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>pkcs11-tool — utility for managing and using PKCS #11 security tokens</p></div><div class="refsynopsisdiv"><h2>Synopsis</h2><div class="cmdsynopsis"><p><code class="command">pkcs11-tool</code>  [<em class="replaceable"><code>OPTIONS</code></em>]</p></div></div><div class="refsect1"><a name="id-1.17.4"></a><h2>Description</h2><p>
 			The <span class="command"><strong>pkcs11-tool</strong></span> utility is used to manage the
 			data objects on smart cards and similar PKCS #11 security tokens.
 			Users can list and read PINs, keys and certificates stored on the
@@ -1476,11 +1491,14 @@ to enable debug output in the opensc lib
 						<code class="option">--key-type</code> <em class="replaceable"><code>specification</code></em>
 					</span></dt><dd><p>Specify the type and length (bytes if symmetric) of the key to create,
 					for example RSA:1024, EC:prime256v1, GOSTR3410-2012-256:B,
-					DES:8, DES3:24, AES:16 or GENERIC:64.</p></dd><dt><span class="term">
+					DES:8, DES3:24, AES:16 or GENERIC:64. If the key type was incompletely specified, possible values are listed.</p></dd><dt><span class="term">
 						<code class="option">--usage-sign</code>
 					</span></dt><dd><p>Specify 'sign' key usage flag (sets SIGN in privkey, sets VERIFY in pubkey).</p></dd><dt><span class="term">
 						<code class="option">--usage-decrypt</code>
-					</span></dt><dd><p>Specify 'decrypt' key usage flag (RSA only, set DECRYPT privkey, ENCRYPT in pubkey).</p></dd><dt><span class="term">
+					</span></dt><dd><p>Specify 'decrypt' key usage flag.</p><p>
+							For RSA keys, sets DECRYPT in privkey and ENCRYPT in pubkey. For secret
+							keys, sets both DECRYPT and ENCRYPT.
+						</p></dd><dt><span class="term">
 						<code class="option">--usage-derive</code>
 					</span></dt><dd><p>Specify 'derive' key usage flag (EC only).</p></dd><dt><span class="term">
 						<code class="option">--usage-wrap</code>
@@ -1495,7 +1513,9 @@ to enable debug output in the opensc lib
 					</span></dt><dd><p>Display a list of mechanisms supported by the token.</p></dd><dt><span class="term">
 						<code class="option">--list-objects</code>,
 						<code class="option">-O</code>
-					</span></dt><dd><p>Display a list of objects.</p></dd><dt><span class="term">
+					</span></dt><dd><p>Display a list of objects.</p><p>The options <code class="option">--keytype</code>, <code class="option">--label</code>
+						, <code class="option">--id</code> or <code class="option">--application-id</code> can be
+						used to filter the listed objects.</p></dd><dt><span class="term">
 						<code class="option">--list-slots</code>,
 						<code class="option">-L</code>
 					</span></dt><dd><p>Display a list of available slots on the token.</p></dd><dt><span class="term">
@@ -1504,6 +1524,8 @@ to enable debug output in the opensc lib
 					</span></dt><dd><p>List slots with tokens.</p></dd><dt><span class="term">
 						<code class="option">--list-interfaces</code>
 					</span></dt><dd><p>List interfaces of PKCS #11 3.0 library.</p></dd><dt><span class="term">
+						<code class="option">--session-rw</code>,
+					</span></dt><dd><p>Forces to open the PKCS#11 session with CKF_RW_SESSION.</p></dd><dt><span class="term">
 						<code class="option">--login</code>,
 						<code class="option">-l</code>
 					</span></dt><dd><p>Authenticate to the token before performing
@@ -1570,6 +1592,12 @@ to enable debug output in the opensc lib
 					</span></dt><dd><p>Sign some data.</p></dd><dt><span class="term">
 						<code class="option">--decrypt</code>,
 					</span></dt><dd><p>Decrypt some data.</p></dd><dt><span class="term">
+						<code class="option">--encrypt</code>,
+					</span></dt><dd><p>Encrypt some data.</p></dd><dt><span class="term">
+						<code class="option">--unwrap</code>,
+					</span></dt><dd><p>Unwrap key.</p></dd><dt><span class="term">
+						<code class="option">--wrap</code>,
+					</span></dt><dd><p>Wrap key.</p></dd><dt><span class="term">
 						<code class="option">--derive</code>,
 					</span></dt><dd><p>Derive a secret key using another key and some data.</p></dd><dt><span class="term">
 						<code class="option">--derive-pass-der</code>,
@@ -1578,7 +1606,9 @@ to enable debug output in the opensc lib
 					</span></dt><dd><p>Specify how many bytes of salt should
 					be used in RSA-PSS signatures. Accepts two special values:
 					"-1" means salt length equals to digest length,
-					"-2" means use maximum permissible length.
+					"-2" or "-3" means use maximum permissible length.
+					For verify operation "-2" means that the salt length is automatically recovered from signature.
+					The value "-2" for the verify operation is supported for opensc pkcs#11 module only.
 					Default is digest length (-1).</p></dd><dt><span class="term">
 						<code class="option">--slot</code> <em class="replaceable"><code>id</code></em>
 					</span></dt><dd><p>Specify the id of the slot to use (accepts HEX format with 0x.. prefix or decimal number).</p></dd><dt><span class="term">
@@ -1680,25 +1710,108 @@ to enable debug output in the opensc lib
 						<code class="option">--allow-sw</code>
 					</span></dt><dd><p>Allow using software mechanisms that do not have the CKF_HW flag set.
 					May be required when using software tokens and emulators.
+					</p></dd><dt><span class="term">
+						<code class="option">--iv</code> <em class="replaceable"><code>data</code></em>
+					</span></dt><dd><p>Initialization vector for symmetric ciphers.
+					The <em class="replaceable"><code>data</code></em> is hexadecimal number, i.e. "000013aa7bffa0".
 					</p></dd></dl></div><p>
 		</p></div><div class="refsect1"><a name="id-1.17.6"></a><h2>Examples</h2><p>
-			To list all certificates on the smart card:
+			Perform a basic functionality test of the card:
+				</p><pre class="programlisting">pkcs11-tool --test --login</pre><p>
+
+			List all certificates on the smart card:
 				</p><pre class="programlisting">pkcs11-tool --list-objects --type cert</pre><p>
 
-			To read the certificate with ID <em class="replaceable"><code>KEY_ID</code></em>
-			in DER format from smart card:
-				</p><pre class="programlisting">pkcs11-tool --read-object --id KEY_ID --type cert --output-file cert.der</pre><p>
-
-			To convert the certificate in DER format to PEM format, use OpenSSL
-			tools:
-				</p><pre class="programlisting">openssl x509 -inform DER -in cert.der -outform PEM &gt; cert.pem</pre><p>
+			Read the certificate with ID <code class="varname">CERT_ID</code>
+			in DER format from smart card and convert it to PEM via OpenSSL:
+			</p><pre class="programlisting">
+pkcs11-tool --read-object --id $CERT_ID --type cert \
+					--output-file cert.der
+openssl x509 -inform DER -in cert.der -outform PEM &gt; cert.pem
+			</pre><p>
+
+			Write a certificate to token:
+				</p><pre class="programlisting">pkcs11-tool --login --write-object certificate.der --type cert</pre><p>
 
-			To sign some data stored in file <em class="replaceable"><code>data</code></em>
-			using the private key with ID <em class="replaceable"><code>ID</code></em> and
+			Generate new RSA Key pair:
+				</p><pre class="programlisting">pkcs11-tool --login --keypairgen --key-type RSA:2048</pre><p>
+
+			Generate new extractable RSA Key pair:
+				</p><pre class="programlisting">pkcs11-tool --login --keypairgen --key-type RSA:2048 --extractable</pre><p>
+
+			Generate an elliptic curve key pair with OpenSSL and import it to the card as <code class="varname">$ID</code>:
+				</p><pre class="programlisting">openssl genpkey -out EC_private.der -outform DER \
+	-algorithm EC -pkeyopt ec_paramgen_curve:P-521
+pkcs11-tool --write-object EC_private.der --id "$ID" \
+	--type privkey --label "EC private key" -p "$PIN"
+openssl pkey -in EC_private.der -out EC_public.der \
+	-pubout -inform DER -outform DER
+pkcs11-tool --write-object EC_public.der --id "$ID" \
+	--type pubkey  --label "EC public key" -p $PIN</pre><p>
+
+			List private keys:
+				</p><pre class="programlisting">pkcs11-tool --login --list-objects --type privkey</pre><p>
+
+			Sign some data stored in file <code class="filename">data</code>
+			using the private key with ID <code class="varname">ID</code> and
 			using the RSA-PKCS mechanism:
-				</p><pre class="programlisting">pkcs11-tool --sign --id ID --mechanism RSA-PKCS --input-file data --output-file data.sig</pre><p>
+			</p><pre class="programlisting">
+pkcs11-tool --sign --id $ID --mechanism RSA-PKCS \
+	--input-file data --output-file data.sig
+			</pre><p>
+			The same is also possible by piping the data from stdin rather than specifying a input file:
+			</p><pre class="programlisting">
+dd if=data bs=128 count=1 \
+	| pkcs11-tool --sign --id $ID --mechanism RSA-PKCS \
+	&gt; data.sig
+			</pre><p>
+
+			Verify the signed data:
+			</p><pre class="programlisting">
+pkcs11-tool --id ID --verify -m RSA-PKCS \
+	--input-file data --signature-file data.sig
+			</pre><p>
+
+			To encrypt file using the AES key with ID 85 and using mechanism AES-CBC with padding:
+				</p><pre class="programlisting">
+pkcs11-tool --login --encrypt --id 85 -m AES-CBC-PAD \
+	--iv "00000000000000000000000000000000" \
+	-i file.txt -o encrypted_file.data
+				</pre><p>
+			Decipher the encrypted file:
+				</p><pre class="programlisting">
+pkcs11-tool --login --decrypt --id 85 -m AES-CBC-PAD \
+	--iv "00000000000000000000000000000000" \
+	--i encrypted_file.data -o decrypted.txt
+				</pre><p>
+
+			Use the key with ID 75 using mechanism AES-CBC-PAD, with initialization vector
+			"00000000000000000000000000000000" to wrap the key with ID 76 into output file
+			<code class="filename">exported_aes.key</code>
+				</p><pre class="programlisting">
+pkcs11-tool --login --wrap --id 75 --mechanism AES-CBC-PAD \
+	--iv "00000000000000000000000000000000" \
+	--application-id 76 \
+	--output-file exported_aes.key
+				</pre><p>
+			Use the key with ID 22 and mechanism RSA-PKCS to unwrap key from file
+			<code class="filename">aes_wrapped.key</code>. After a successful unwrap operation,
+			a new AES key is created on token. ID of this key is set to 90 and label of this
+			key is set to <code class="literal">unwrapped-key</code>
+			Note: for the MyEID card, the AES key size must be present in key
+			specification i.e. AES:16
+				</p><pre class="programlisting">
+pkcs11-tool --login --unwrap --mechanism RSA-PKCS --id 22 \
+	-i aes_wrapped.key --key-type AES: \
+	--application-id 90 --applicatin-label unwrapped-key
+				</pre><p>
+
+			Use the SO-PIN to initialize or re-set the PIN:
+				</p><pre class="programlisting">
+pkcs11-tool --login --login-type so --init-pin
+				</pre><p>
 		</p></div><div class="refsect1"><a name="id-1.17.7"></a><h2>Authors</h2><p><span class="command"><strong>pkcs11-tool</strong></span> was written by
-		Olaf Kirch <code class="email">&lt;<a class="email" href="mailto:okir@suse.de">okir@suse.de</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="pkcs15-crypt"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>pkcs15-crypt &#8212; perform crypto operations using PKCS#15 smart cards</p></div><div class="refsynopsisdiv"><h2>Synopsis</h2><div class="cmdsynopsis"><p><code class="command">pkcs15-crypt</code>  [<em class="replaceable"><code>OPTIONS</code></em>]</p></div></div><div class="refsect1"><a name="id-1.18.4"></a><h2>Description</h2><p>
+		Olaf Kirch <code class="email">&lt;<a class="email" href="mailto:okir@suse.de">okir@suse.de</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="pkcs15-crypt"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>pkcs15-crypt — perform crypto operations using PKCS#15 smart cards</p></div><div class="refsynopsisdiv"><h2>Synopsis</h2><div class="cmdsynopsis"><p><code class="command">pkcs15-crypt</code>  [<em class="replaceable"><code>OPTIONS</code></em>]</p></div></div><div class="refsect1"><a name="id-1.18.4"></a><h2>Description</h2><p>
 			The <span class="command"><strong>pkcs15-crypt</strong></span> utility can be used from the
 			command line to perform cryptographic operations such as computing
 			digital signatures or decrypting data, using keys stored on a PKCS#15
@@ -1804,7 +1917,7 @@ to enable debug output in the opensc lib
 			<span class="citerefentry"><span class="refentrytitle">pkcs15-init</span>(1)</span>,
 			<span class="citerefentry"><span class="refentrytitle">pkcs15-tool</span>(1)</span>
 		</p></div><div class="refsect1"><a name="id-1.18.7"></a><h2>Authors</h2><p><span class="command"><strong>pkcs15-crypt</strong></span> was written by
-		Juha Yrjölä <code class="email">&lt;<a class="email" href="mailto:juha.yrjola@iki.fi">juha.yrjola@iki.fi</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="pkcs15-init"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>pkcs15-init &#8212; smart card personalization utility</p></div><div class="refsynopsisdiv"><h2>Synopsis</h2><div class="cmdsynopsis"><p><code class="command">pkcs15-init</code>  [<em class="replaceable"><code>OPTIONS</code></em>]</p></div></div><div class="refsect1"><a name="id-1.19.5"></a><h2>Description</h2><p>
+		Juha Yrjölä <code class="email">&lt;<a class="email" href="mailto:juha.yrjola@iki.fi">juha.yrjola@iki.fi</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="pkcs15-init"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>pkcs15-init — smart card personalization utility</p></div><div class="refsynopsisdiv"><h2>Synopsis</h2><div class="cmdsynopsis"><p><code class="command">pkcs15-init</code>  [<em class="replaceable"><code>OPTIONS</code></em>]</p></div></div><div class="refsect1"><a name="id-1.19.5"></a><h2>Description</h2><p>
 			The <span class="command"><strong>pkcs15-init</strong></span> utility can be used to create a PKCS #15
 			structure on a smart card, and add key or certificate objects. Details of the
 			structure that will be created are controlled via profiles.
@@ -1871,7 +1984,7 @@ to enable debug output in the opensc lib
 				<span class="command"><strong>pkcs15-init</strong></span> lets you generate a new key and store it on the card.
 				You can do this using:
 			</p><p>
-				<span class="command"><strong>pkcs15-init --generate-key " keyspec " --auth-id " nn</strong></span>
+				<span class="command"><strong>pkcs15-init --generate-key "keyspec" --auth-id "nn"</strong></span>
 			</p><p>
 				where <em class="replaceable"><code>keyspec</code></em> describes the algorithm and the parameters
 				of the key to be created. For example, <code class="literal">rsa:2048</code> generates a RSA key
@@ -2153,8 +2266,7 @@ to enable debug output in the opensc lib
 							Tells <span class="command"><strong>pkcs15-init</strong></span> to not ask for the transport
 							keys and use default keys, as known by the card driver.
 						</p></dd><dt><span class="term">
-						<code class="option">--sanity-check</code>,
-						<code class="option">-T</code>
+						<code class="option">--sanity-check</code>
 					</span></dt><dd><p>
 							Tells <span class="command"><strong>pkcs15-init</strong></span> to perform a
 							card specific sanity check and possibly update
@@ -2180,10 +2292,19 @@ to enable debug output in the opensc lib
 							wait for a card insertion.</p></dd><dt><span class="term">
 						<code class="option">--use-pinpad</code>
 					</span></dt><dd><p>Do not prompt the user; if no PINs supplied, pinpad will be used.</p></dd><dt><span class="term">
+						<code class="option">--auth-id</code> <em class="replaceable"><code>filename</code></em>,
+						<code class="option">-a</code> <em class="replaceable"><code>filename</code></em>
+					</span></dt><dd><p>
+							Specify ID of PIN to use/create
+						</p></dd><dt><span class="term">
 						<code class="option">--puk-id</code> <em class="replaceable"><code>ID</code></em>
 					</span></dt><dd><p>
 							Specify ID of PUK to use/create
 						</p></dd><dt><span class="term">
+						<code class="option">--label</code> <em class="replaceable"><code>LABEL</code></em>
+					</span></dt><dd><p>
+							Specify label for a PIN, key, certificate or data object when creating a new objects. When deleting objects, this can be used to delete object by label.
+						</p></dd><dt><span class="term">
 						<code class="option">--puk-label</code> <em class="replaceable"><code>LABEL</code></em>
 					</span></dt><dd><p>
 							Specify label of PUK
@@ -2283,7 +2404,7 @@ to enable debug output in the opensc lib
 		</p></div><div class="refsect1"><a name="id-1.19.9"></a><h2>See also</h2><p>
 			<span class="citerefentry"><span class="refentrytitle">pkcs15-profile</span>(5)</span>
 		</p></div><div class="refsect1"><a name="id-1.19.10"></a><h2>Authors</h2><p><span class="command"><strong>pkcs15-init</strong></span> was written by
-		Olaf Kirch <code class="email">&lt;<a class="email" href="mailto:okir@suse.de">okir@suse.de</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="pkcs15-tool"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>pkcs15-tool &#8212; utility for manipulating PKCS #15 data structures
+		Olaf Kirch <code class="email">&lt;<a class="email" href="mailto:okir@suse.de">okir@suse.de</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="pkcs15-tool"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>pkcs15-tool — utility for manipulating PKCS #15 data structures
 		on smart cards and similar security tokens</p></div><div class="refsynopsisdiv"><h2>Synopsis</h2><div class="cmdsynopsis"><p><code class="command">pkcs15-tool</code>  [<em class="replaceable"><code>OPTIONS</code></em>]</p></div></div><div class="refsect1"><a name="id-1.20.4"></a><h2>Description</h2><p>
 			The <span class="command"><strong>pkcs15-tool</strong></span> utility is used to manipulate
 			the PKCS #15 data structures on smart cards and similar security
@@ -2292,7 +2413,7 @@ to enable debug output in the opensc lib
 			operations that require it.
 		</p></div><div class="refsect1"><a name="id-1.20.5"></a><h2>Options</h2><p>
 			</p><div class="variablelist"><dl class="variablelist"><dt><span class="term">
-                                                <code class="option">--version</code>,
+                                                <code class="option">--version</code>
                                         </span></dt><dd><p>Print the OpenSC package release version.</p></dd><dt><span class="term">
 						<code class="option">--aid</code> <em class="replaceable"><code>aid</code></em>
 					</span></dt><dd><p>Specify in a hexadecimal form the AID of the on-card PKCS#15
@@ -2342,7 +2463,7 @@ to enable debug output in the opensc lib
 						<code class="option">--list-public-keys</code>
 					</span></dt><dd><p>List all public keys stored on the token, including
 					key name, id, algorithm and length information.</p></dd><dt><span class="term">
-						<code class="option">--short</code>
+						<code class="option">--short</code>,
 						<code class="option">-s</code>
 					</span></dt><dd><p>Output lists in compact format.</p></dd><dt><span class="term">
 						<code class="option">--no-cache</code>
@@ -2352,11 +2473,6 @@ to enable debug output in the opensc lib
 					Windows, this option additionally removes the system's
 					caching directory (requires administrator
 					privileges).</p></dd><dt><span class="term">
-						<code class="option">--clear-cache</code>
-					</span></dt><dd><p>Removes the user's cache directory. On
-					Windows, this option additionally removes the system's
-					caching directory (requires administrator
-					privileges).</p></dd><dt><span class="term">
 						<code class="option">--output</code> <em class="replaceable"><code>filename</code></em>,
 						<code class="option">-o</code> <em class="replaceable"><code>filename</code></em>
 					</span></dt><dd><p>Specifies where key output should be written.
@@ -2371,7 +2487,7 @@ to enable debug output in the opensc lib
 					always be in raw binary.</p></dd><dt><span class="term">
 						<code class="option">--read-certificate</code> <em class="replaceable"><code>cert</code></em>
 					</span></dt><dd><p>Reads the certificate with the given id.</p></dd><dt><span class="term">
-						<code class="option">--read-data-object</code> <em class="replaceable"><code>cert</code></em>,
+						<code class="option">--read-data-object</code> <em class="replaceable"><code>data</code></em>,
 						<code class="option">-R</code> <em class="replaceable"><code>data</code></em>
 					</span></dt><dd><p>Reads data object with OID, applicationName or label.
 					The content is printed to standard output in hex notation, unless
@@ -2391,10 +2507,10 @@ to enable debug output in the opensc lib
 						</span></dt><dd><p>When used in conjunction with option <code class="option">--read-ssh-key</code> the
 						output format of the public key follows rfc4716.</p></dd><p></p><p> The default output format is a single line (openssh).</p></dd><dt><span class="term">
 						<code class="option">--test-update</code>,
-						<code class="option">-T</code>,
+						<code class="option">-T</code>
 					</span></dt><dd><p>Test if the card needs a security update</p></dd><dt><span class="term">
 						<code class="option">--update</code>,
-						<code class="option">-U</code>,
+						<code class="option">-U</code>
 					</span></dt><dd><p>Update the card with a security update</p></dd><dt><span class="term">
 						<code class="option">--reader</code> <em class="replaceable"><code>arg</code></em>
 					</span></dt><dd><p>
@@ -2413,7 +2529,7 @@ to enable debug output in the opensc lib
 					verbose. Specify this flag several times to enable debug output
 					in the OpenSC library.</p></dd><dt><span class="term">
 						<code class="option">--pin</code> <em class="replaceable"><code>pin</code></em>,
-						<code class="option">--new-pin</code> <em class="replaceable"><code>newpin</code></em>
+						<code class="option">--new-pin</code> <em class="replaceable"><code>newpin</code></em>,
 						<code class="option">--puk</code> <em class="replaceable"><code>puk</code></em>
 					</span></dt><dd><p>
 							These options can be used to specify the PIN/PUK values
@@ -2447,7 +2563,7 @@ to enable debug output in the opensc lib
 			<span class="citerefentry"><span class="refentrytitle">pkcs15-init</span>(1)</span>,
 			<span class="citerefentry"><span class="refentrytitle">pkcs15-crypt</span>(1)</span>
 		</p></div><div class="refsect1"><a name="id-1.20.7"></a><h2>Authors</h2><p><span class="command"><strong>pkcs15-tool</strong></span> was written by
-		Juha Yrjölä <code class="email">&lt;<a class="email" href="mailto:juha.yrjola@iki.fi">juha.yrjola@iki.fi</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="sc-hsm-tool"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>sc-hsm-tool &#8212; smart card utility for SmartCard-HSM</p></div><div class="refsynopsisdiv"><h2>Synopsis</h2><div class="cmdsynopsis"><p><code class="command">sc-hsm-tool</code>  [<em class="replaceable"><code>OPTIONS</code></em>]</p></div></div><div class="refsect1"><a name="id-1.21.4"></a><p>
+		Juha Yrjölä <code class="email">&lt;<a class="email" href="mailto:juha.yrjola@iki.fi">juha.yrjola@iki.fi</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="sc-hsm-tool"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>sc-hsm-tool — smart card utility for SmartCard-HSM</p></div><div class="refsynopsisdiv"><h2>Synopsis</h2><div class="cmdsynopsis"><p><code class="command">sc-hsm-tool</code>  [<em class="replaceable"><code>OPTIONS</code></em>]</p></div></div><div class="refsect1"><a name="id-1.21.4"></a><p>
 			The <span class="command"><strong>sc-hsm-tool</strong></span> utility can be used from the command line to perform
 			extended maintenance tasks not available via PKCS#11 or other tools in the OpenSC package.
 			It can be used to query the status of a SmartCard-HSM, initialize a device, generate and import
@@ -2457,7 +2573,7 @@ to enable debug output in the opensc lib
 						<code class="option">--initialize</code>,
 						<code class="option">-X</code>
 					</span></dt><dd><p>Initialize token, removing all existing keys, certificates and files.</p><p>Use <code class="option">--so-pin</code> to define SO-PIN for first initialization or to verify in subsequent
-					          initializations.</p><p>Use <code class="option">--pin</code> to define the initial user pin value.</p><p>Use <code class="option">--pin-retry</code> to define the maximum number of wrong user PIN presentations.</p><p>Use with <code class="option">--dkek-shares</code> to enable key wrap / unwrap.</p><p>Use with <code class="option">--label</code> to define a token label</p></dd><dt><span class="term">
+					          initializations.</p><p>Use <code class="option">--pin</code> to define the initial user pin value.</p><p>Use <code class="option">--pin-retry</code> to define the maximum number of wrong user PIN presentations.</p><p>Use with <code class="option">--dkek-shares</code> to enable key wrap / unwrap.</p><p>Use with <code class="option">--label</code> to define a token label</p><p>Use with <code class="option">--public-key-auth</code> and <code class="option">--required-pub-keys</code> to require public key authentication for login</p></dd><dt><span class="term">
 						<code class="option">--create-dkek-share</code> <em class="replaceable"><code>filename</code></em>,
 						<code class="option">-C</code> <em class="replaceable"><code>filename</code></em>
 					</span></dt><dd><p>Create a DKEK share encrypted under a password and save it to the file
@@ -2525,6 +2641,38 @@ to enable debug output in the opensc lib
 							<em class="replaceable"><code>arg</code></em> is an ATR, the
 							reader with a matching card will be chosen.
 						</p></dd><dt><span class="term">
+						<code class="option">--public-key-auth</code> <em class="replaceable"><code>total-number-of-public-keys</code></em>,
+						<code class="option">-K</code> <em class="replaceable"><code>total-number-of-public-keys</code></em>
+					</span></dt><dd><p>Define the total number of public keys to use for public key authentication when using <code class="option">--initialize</code>.
+							  <code class="option">--public-key-auth</code> is optional, but if it's present, it must be used with <code class="option">--required-pub-keys</code>.
+						</p><p>When the SmartCard-HSM is initialized with these options, it will require M-of-N public key authentication to be used, where
+							<code class="option">--required-pub-keys</code> sets the M and <code class="option">--public-key-auth</code> sets the N. After the initialization,
+							the user should use <code class="option">--register-public-key</code> to register the N public keys before the SmartCard-HSM can be used.
+						</p></dd><dt><span class="term">
+						<code class="option">--required-pub-keys</code> <em class="replaceable"><code>required-number-of-public-keys</code></em>,
+						<code class="option">-n</code> <em class="replaceable"><code>required-number-of-public-keys</code></em>
+					</span></dt><dd><p>Define the required number of public keys to use for public key authentication when using <code class="option">--initialize</code>.
+							  This is the M in M-of-N public key authentication. See <code class="option">--public-key-auth</code> for more information.
+						</p></dd><dt><span class="term">
+						<code class="option">--register-public-key</code> <em class="replaceable"><code>input-public-key-file</code></em>,
+						<code class="option">-g</code> <em class="replaceable"><code>input-public-key-file</code></em>
+					</span></dt><dd><p>Register a public key to be used for M-of-N public key authentication. The file can be exported from
+							  a different SmartCard-HSM with <code class="option">--export-for-pub-key-auth</code>. This can only be used when the
+							  SmartCard-HSM has been initialized with <code class="option">--public-key-auth</code> and <code class="option">--required-pub-keys</code>
+							  and fewer than N public keys have been registered. Use <code class="option">--public-key-auth-status</code> to check the
+							  how many public keys have been registered.
+						</p></dd><dt><span class="term">
+						<code class="option">--export-for-pub-key-auth</code> <em class="replaceable"><code>output-public-key-file</code></em>,
+						<code class="option">-e</code> <em class="replaceable"><code>output-public-key-file</code></em>
+					</span></dt><dd><p>Export a public key to be used for M-of-N public key authentication. This should be used with
+							  <code class="option">--key-reference</code> to choose the key to export. The file should be registered on
+							  another SmartCard-HSM using <code class="option">--register-public-key</code>.
+						</p></dd><dt><span class="term">
+						<code class="option">--public-key-auth-status</code>
+						<code class="option">-S</code>
+					</span></dt><dd><p>Print the public key authentication status. This is only valid if the SmartCard-HSM was initialized
+							  to use M-of-N public key authentication.
+						</p></dd><dt><span class="term">
 						<code class="option">--wait</code>,
 						<code class="option">-w</code>
 					</span></dt><dd><p>Wait for a card to be inserted</p></dd><dt><span class="term">
@@ -2533,10 +2681,10 @@ to enable debug output in the opensc lib
 					</span></dt><dd><p>Causes <span class="command"><strong>sc-hsm-tool</strong></span> to be more verbose.
 					Specify this flag several times to enable debug output in the opensc
 					library.</p></dd></dl></div><p>
-		</p></div><div class="refsect1"><a name="id-1.21.6"></a><h2>Examples</h2><p>Create a DKEK share:</p><p><span class="command"><strong>sc-hsm-tool --create-dkek-share dkek-share-1.pbe</strong></span></p><p>Create a DKEK share with random password split up using a (3, 5) threshold scheme:</p><p><span class="command"><strong>sc-hsm-tool --create-dkek-share dkek-share-1.pbe --pwd-shares-threshold 3 --pwd-shares-total 5</strong></span></p><p>Initialize SmartCard-HSM to use a single DKEK share:</p><p><span class="command"><strong>sc-hsm-tool --initialize --so-pin 3537363231383830 --pin 648219 --dkek-shares 1 --label mytoken</strong></span></p><p>Import DKEK share:</p><p><span class="command"><strong>sc-hsm-tool --import-dkek-share dkek-share-1.pbe</strong></span></p><p>Import DKEK share using a password split up using a (3, 5) threshold scheme for encryption:</p><p><span class="command"><strong>sc-hsm-tool --import-dkek-share dkek-share-1.pbe  --pwd-shares-total 3</strong></span></p><p>Wrap referenced key, description and certificate:</p><p><span class="command"><strong>sc-hsm-tool --wrap-key wrap-key.bin --key-reference 1 --pin 648219</strong></span></p><p>Unwrap key into same or in different SmartCard-HSM with the same DKEK:</p><p><span class="command"><strong>sc-hsm-tool --unwrap-key wrap-key.bin --key-reference 10 --pin 648219 --force</strong></span></p></div><div class="refsect1"><a name="id-1.21.7"></a><h2>See also</h2><p>
+		</p></div><div class="refsect1"><a name="id-1.21.6"></a><h2>Examples</h2><p>Create a DKEK share:</p><p><span class="command"><strong>sc-hsm-tool --create-dkek-share dkek-share-1.pbe</strong></span></p><p>Create a DKEK share with random password split up using a (3, 5) threshold scheme:</p><p><span class="command"><strong>sc-hsm-tool --create-dkek-share dkek-share-1.pbe --pwd-shares-threshold 3 --pwd-shares-total 5</strong></span></p><p>Initialize SmartCard-HSM to use a single DKEK share:</p><p><span class="command"><strong>sc-hsm-tool --initialize --so-pin 3537363231383830 --pin 648219 --dkek-shares 1 --label mytoken</strong></span></p><p>Import DKEK share:</p><p><span class="command"><strong>sc-hsm-tool --import-dkek-share dkek-share-1.pbe</strong></span></p><p>Import DKEK share using a password split up using a (3, 5) threshold scheme for encryption:</p><p><span class="command"><strong>sc-hsm-tool --import-dkek-share dkek-share-1.pbe  --pwd-shares-total 3</strong></span></p><p>Wrap referenced key, description and certificate:</p><p><span class="command"><strong>sc-hsm-tool --wrap-key wrap-key.bin --key-reference 1 --pin 648219</strong></span></p><p>Unwrap key into same or in different SmartCard-HSM with the same DKEK:</p><p><span class="command"><strong>sc-hsm-tool --unwrap-key wrap-key.bin --key-reference 10 --pin 648219 --force</strong></span></p><p>Initialize SmartCard-HSM to use M-of-N public key authentication with M=2 and N=5</p><p><span class="command"><strong>sc-hsm-tool --initialize --required-pub-keys 2 --public-key-auth 5</strong></span></p><p>Export a public key for M-of-N public key authentication to a file</p><p><span class="command"><strong>sc-hsm-tool --key-reference 1 --export-for-pub-key-auth ./public_key1.asn1</strong></span></p><p>Register a public key for M-of-N public key authentication from a file</p><p><span class="command"><strong>sc-hsm-tool --register-public-key ./public_key1.asn1</strong></span></p></div><div class="refsect1"><a name="id-1.21.7"></a><h2>See also</h2><p>
 			<span class="citerefentry"><span class="refentrytitle">opensc-tool</span>(1)</span>
 		</p></div><div class="refsect1"><a name="id-1.21.8"></a><h2>Authors</h2><p><span class="command"><strong>sc-hsm-tool</strong></span> was written by
-		Andreas Schwier <code class="email">&lt;<a class="email" href="mailto:andreas.schwier@cardcontact.de">andreas.schwier@cardcontact.de</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="westcos-tool"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>westcos-tool &#8212; utility for manipulating data structures
+		Andreas Schwier <code class="email">&lt;<a class="email" href="mailto:andreas.schwier@cardcontact.de">andreas.schwier@cardcontact.de</a>&gt;</code>.</p></div></div><div class="refentry"><div class="refentry.separator"><hr></div><a name="westcos-tool"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>westcos-tool — utility for manipulating data structures
 			on westcos smart cards</p></div><div class="refsynopsisdiv"><h2>Synopsis</h2><div class="cmdsynopsis"><p><code class="command">westcos-tool</code>  [<em class="replaceable"><code>OPTIONS</code></em>]</p></div></div><div class="refsect1"><a name="id-1.22.4"></a><h2>Description</h2><p>
 			The <span class="command"><strong>westcos-tool</strong></span> utility is used to manipulate
 			the westcos data structures on 2 Ko smart cards / tokens. Users can create PINs,
@@ -2565,7 +2713,7 @@ to enable debug output in the opensc lib
 					</span></dt><dd><p>Generate a private key on the card. The card must not have
 					been finalized and a PIN must be installed (i.e. the file for the PIN must
 					have been created, see option <code class="option">-i</code>).
-					By default the key length is 1536 bits. User authentication is required for
+					By default the key length is 2048 bits. User authentication is required for
 					this operation. </p></dd><dt><span class="term">
 						<code class="option">--help</code>,
 						<code class="option">-h</code>
diff -pruN 0.25.0~rc1-1/packaging/opensc.spec 0.25.1-1/packaging/opensc.spec
--- 0.25.0~rc1-1/packaging/opensc.spec	2024-02-17 23:32:31.000000000 +0000
+++ 0.25.1-1/packaging/opensc.spec	2024-04-04 14:21:38.000000000 +0000
@@ -158,6 +158,7 @@ rm %{buildroot}%{_mandir}/man1/opensc-no
 %{_bindir}/westcos-tool
 %{_bindir}/egk-tool
 %{_bindir}/goid-tool
+%{_bindir}/dtrust-tool
 %{_libdir}/lib*.so.*
 %{_libdir}/opensc-pkcs11.so
 %{_libdir}/pkcs11-spy.so
@@ -187,4 +188,5 @@ rm %{buildroot}%{_mandir}/man1/opensc-no
 %{_mandir}/man1/westcos-tool.1*
 %{_mandir}/man1/dnie-tool.1*
 %{_mandir}/man1/egk-tool.1*
+%{_mandir}/man1/dtrust-tool.1*
 %{_mandir}/man5/pkcs15-profile.5*
diff -pruN 0.25.0~rc1-1/src/libopensc/card-epass2003.c 0.25.1-1/src/libopensc/card-epass2003.c
--- 0.25.0~rc1-1/src/libopensc/card-epass2003.c	2024-02-17 23:32:31.000000000 +0000
+++ 0.25.1-1/src/libopensc/card-epass2003.c	2024-04-04 14:21:38.000000000 +0000
@@ -3085,11 +3085,11 @@ epass2003_gen_key(struct sc_card *card,
 		size_t yCoordinateLen;
 		unsigned char *tmp;
 
-		if (2 + xCoordinateLen + 1 >= apdu.resplen) {
+		if (2 + xCoordinateLen + 1 > apdu.resplen) {
 			LOG_FUNC_RETURN(card->ctx, SC_ERROR_INVALID_DATA);
 		}
 		yCoordinateLen = rbuf[2 + xCoordinateLen + 1];
-		if (2 + xCoordinateLen + 2 + yCoordinateLen >= apdu.resplen) {
+		if (2 + xCoordinateLen + 2 + yCoordinateLen > apdu.resplen) {
 			LOG_FUNC_RETURN(card->ctx, SC_ERROR_INVALID_DATA);
 		}
 		data->modulus_len = xCoordinateLen + yCoordinateLen;
diff -pruN 0.25.0~rc1-1/src/libopensc/card-idprime.c 0.25.1-1/src/libopensc/card-idprime.c
--- 0.25.0~rc1-1/src/libopensc/card-idprime.c	2024-02-17 23:32:31.000000000 +0000
+++ 0.25.1-1/src/libopensc/card-idprime.c	2024-04-04 14:21:38.000000000 +0000
@@ -57,6 +57,10 @@ static const struct sc_atr_table idprime
 	  "ff:ff:00:ff:ff:ff:ff:ff:ff:ff:ff:ff:ff:ff:ff:00:00:ff:ff:ff",
 	  "Gemalto IDPrime 930/3930",
 	  SC_CARD_TYPE_IDPRIME_930, 0, NULL },
+	{ "3b:ff:96:00:00:81:31:fe:43:80:31:80:65:b0:84:65:66:fb:12:01:78:82:90:00:85",
+	  "ff:ff:00:ff:ff:ff:ff:00:ff:ff:ff:ff:ff:ff:00:00:00:00:ff:ff:ff:ff:ff:ff:00",
+	  "based Gemalto IDPrime 930",
+	  SC_CARD_TYPE_IDPRIME_930, 0, NULL },
 	{ "3b:7f:96:00:00:80:31:80:65:b0:85:59:56:fb:12:0f:fe:82:90:00",
 	  "ff:ff:00:ff:ff:ff:ff:ff:ff:ff:ff:00:00:00:ff:00:00:ff:ff:ff",
 	  "Gemalto IDPrime 940",
@@ -648,10 +652,8 @@ static int idprime_init(sc_card_t *card)
 	if (card->type == SC_CARD_TYPE_IDPRIME_930
 	    || card->type == SC_CARD_TYPE_IDPRIME_940) {
 		_sc_card_add_rsa_alg(card, 4096, flags, 0);
-	}
 
-	/* Set up algorithm info for EC */
-	if (card->type == SC_CARD_TYPE_IDPRIME_940) {
+		/* Set up algorithm info for EC */
 		flags = SC_ALGORITHM_ECDSA_RAW | SC_ALGORITHM_ECDSA_HASH_NONE;
 		ext_flags = SC_ALGORITHM_EXT_EC_F_P
 			| SC_ALGORITHM_EXT_EC_ECPARAMETERS
diff -pruN 0.25.0~rc1-1/src/libopensc/card-openpgp.c 0.25.1-1/src/libopensc/card-openpgp.c
--- 0.25.0~rc1-1/src/libopensc/card-openpgp.c	2024-02-17 23:32:31.000000000 +0000
+++ 0.25.1-1/src/libopensc/card-openpgp.c	2024-04-04 14:21:38.000000000 +0000
@@ -2494,7 +2494,7 @@ pgp_update_new_algo_attr(sc_card_t *card
 	pgp_blob_t *algo_blob;
 	const unsigned int tag = 0x00C0 | key_info->key_id;
 	u8 *data;
-	int data_len;
+	size_t data_len;
 	int r = SC_SUCCESS;
 	unsigned int i;
 
diff -pruN 0.25.0~rc1-1/src/libopensc/padding.c 0.25.1-1/src/libopensc/padding.c
--- 0.25.0~rc1-1/src/libopensc/padding.c	2024-02-17 23:32:31.000000000 +0000
+++ 0.25.1-1/src/libopensc/padding.c	2024-04-04 14:21:38.000000000 +0000
@@ -154,13 +154,15 @@ sc_pkcs1_strip_02_padding_constant_time(
 {
 	unsigned int i = 0;
 	u8 *msg, *msg_orig = NULL;
-	unsigned int good, found_zero_byte, mask;
+	unsigned int good, found_zero_byte, mask, tmp_outlen;
 	unsigned int zero_index = 0, msg_index, mlen = -1, len = 0;
 	LOG_FUNC_CALLED(ctx);
 
-	if (data == NULL || data_len <= 0 || data_len > n || n < SC_PKCS1_PADDING_MIN_SIZE)
+	if (data == NULL || data_len <= 0 || data_len > n ||
+			n < SC_PKCS1_PADDING_MIN_SIZE || out_len == NULL)
 		LOG_FUNC_RETURN(ctx, SC_ERROR_INTERNAL);
 
+	tmp_outlen = *out_len;
 	msg = msg_orig = calloc(n, sizeof(u8));
 	if (msg == NULL)
 		LOG_FUNC_RETURN(ctx, SC_ERROR_INTERNAL);
@@ -201,18 +203,18 @@ sc_pkcs1_strip_02_padding_constant_time(
 	mlen = data_len - msg_index;
 
 	// check that message fits into out buffer
-	good &= constant_time_ge(*out_len, mlen);
+	good &= constant_time_ge(tmp_outlen, mlen);
 
 	// move the result in-place by |num|-SC_PKCS1_PADDING_MIN_SIZE-|mlen| bytes to the left.
-	*out_len = constant_time_select(constant_time_lt(n - SC_PKCS1_PADDING_MIN_SIZE, *out_len),
-			n - SC_PKCS1_PADDING_MIN_SIZE, *out_len);
+	tmp_outlen = constant_time_select(constant_time_lt(n - SC_PKCS1_PADDING_MIN_SIZE, tmp_outlen),
+			n - SC_PKCS1_PADDING_MIN_SIZE, tmp_outlen);
 	for (msg_index = 1; msg_index < n - SC_PKCS1_PADDING_MIN_SIZE; msg_index <<= 1) {
 		mask = ~constant_time_eq(msg_index & (n - SC_PKCS1_PADDING_MIN_SIZE - mlen), 0);
 		for (i = SC_PKCS1_PADDING_MIN_SIZE; i < n - msg_index; i++)
 			msg[i] = constant_time_select_8(mask, msg[i + msg_index], msg[i]);
 	}
 	// move message into out buffer, if good
-	for (i = 0; i < *out_len; i++) {
+	for (i = 0; i < tmp_outlen; i++) {
 		unsigned int msg_index;
 		// when out is longer than message in data, use some bogus index in msg
 		mask = good & constant_time_lt(i, mlen);
@@ -220,6 +222,7 @@ sc_pkcs1_strip_02_padding_constant_time(
 		out[i] = constant_time_select_8(mask, msg[msg_index], out[i]);
 	}
 
+	*out_len = constant_time_select(good, mlen, *out_len);
 	free(msg_orig);
 	return constant_time_select(good, mlen, SC_ERROR_WRONG_PADDING);
 }
diff -pruN 0.25.0~rc1-1/src/libopensc/pkcs15-openpgp.c 0.25.1-1/src/libopensc/pkcs15-openpgp.c
--- 0.25.0~rc1-1/src/libopensc/pkcs15-openpgp.c	2024-02-17 23:32:31.000000000 +0000
+++ 0.25.1-1/src/libopensc/pkcs15-openpgp.c	2024-04-04 14:21:38.000000000 +0000
@@ -182,6 +182,7 @@ sc_pkcs15emu_openpgp_init(sc_pkcs15_card
 {
 	sc_card_t	*card = p15card->card;
 	sc_context_t	*ctx = card->ctx;
+	struct pgp_priv_data *priv = DRVDATA(card);
 	char		string[256];
 	u8		c4data[10];
 	u8		c5data[100];
@@ -402,6 +403,10 @@ sc_pkcs15emu_openpgp_init(sc_pkcs15_card
 
 			case SC_OPENPGP_KEYALGO_RSA:
 				if (cxdata_len >= 3) {
+					/* with Authentication key, can only decrypt if can change MSE */
+					if (i == 2 && !(priv->ext_caps & EXT_CAP_MSE)) {
+						prkey_info.usage &= ~PGP_ENC_PRKEY_USAGE;
+					}
 					prkey_info.modulus_length = bebytes2ushort(cxdata + 1);
 					r = sc_pkcs15emu_add_rsa_prkey(p15card, &prkey_obj, &prkey_info);
 					break;
@@ -526,6 +531,10 @@ sc_pkcs15emu_openpgp_init(sc_pkcs15_card
 				break;
 			case SC_OPENPGP_KEYALGO_RSA:
 				if (cxdata_len >= 3) {
+					/* with Authentication pubkey, can only encrypt if can change MSE */
+					if (i == 2 && !(priv->ext_caps & EXT_CAP_MSE)) {
+						pubkey_info.usage &= ~PGP_ENC_PUBKEY_USAGE;
+					}
 					pubkey_info.modulus_length = bebytes2ushort(cxdata + 1);
 					r = sc_pkcs15emu_add_rsa_pubkey(p15card, &pubkey_obj, &pubkey_info);
 					break;
diff -pruN 0.25.0~rc1-1/src/libopensc/pkcs15-prkey.c 0.25.1-1/src/libopensc/pkcs15-prkey.c
--- 0.25.0~rc1-1/src/libopensc/pkcs15-prkey.c	2024-02-17 23:32:31.000000000 +0000
+++ 0.25.1-1/src/libopensc/pkcs15-prkey.c	2024-04-04 14:21:38.000000000 +0000
@@ -240,7 +240,7 @@ int sc_pkcs15_decode_prkdf_entry(struct
 	else if (asn1_prkey[1].flags & SC_ASN1_PRESENT) {
 		obj->type = SC_PKCS15_TYPE_PRKEY_EC;
 #ifdef ENABLE_OPENSSL
-		if (!info.field_length && ec_domain_len) {
+		if (!(asn1_ecckey_attr[1].flags & SC_ASN1_PRESENT) && (asn1_ecckey_attr[3].flags & SC_ASN1_PRESENT)) {
 			const unsigned char *p = ec_domain;
 			ASN1_OBJECT *object = d2i_ASN1_OBJECT(NULL, &p, ec_domain_len);
 			int nid;
diff -pruN 0.25.0~rc1-1/src/minidriver/minidriver.c 0.25.1-1/src/minidriver/minidriver.c
--- 0.25.0~rc1-1/src/minidriver/minidriver.c	2024-02-17 23:32:31.000000000 +0000
+++ 0.25.1-1/src/minidriver/minidriver.c	2024-04-04 14:21:38.000000000 +0000
@@ -513,9 +513,12 @@ get_pin_by_name(PCARD_DATA pCardData, st
 	if (!conf_block)
 		MD_FUNC_RETURN(pCardData, 1, SCARD_F_INTERNAL_ERROR);
 
-	memset(str_path, 0, sizeof(str_path));
-	sc_bin_to_hex(p15card->app->path.value, p15card->app->path.len, str_path, sizeof(str_path), 0);
-	blocks = scconf_find_blocks(p15card->card->ctx->conf, conf_block, "application", str_path);
+	if (p15card->app != NULL) {
+		memset(str_path, 0, sizeof(str_path));
+		sc_bin_to_hex(p15card->app->path.value, p15card->app->path.len, str_path, sizeof(str_path), 0);
+		blocks = scconf_find_blocks(p15card->card->ctx->conf, conf_block, "application", str_path);
+	}
+
 	if (blocks)   {
 		if (blocks[0]) {
 			pin = (char *)scconf_get_str(blocks[0], pin_type, NULL);
@@ -4710,7 +4713,7 @@ DWORD WINAPI CardRSADecrypt(__in PCARD_D
 		goto err;
 	}
 
-	good = constant_time_eq_i(r, 0);
+	good = constant_time_ge(r, 1);
 	/* if no error or padding error, do not return here to prevent Marvin attack */
 	if (!(good | wrong_padding) && r < 0)   {
 		logprintf(pCardData, 2, "sc_pkcs15_decipher error(%i): %s\n", r, sc_strerror(r));
@@ -4721,18 +4724,16 @@ DWORD WINAPI CardRSADecrypt(__in PCARD_D
 	}
 	dwret = constant_time_select_s(good, SCARD_S_SUCCESS, SCARD_F_INTERNAL_ERROR);
 
-	logprintf(pCardData, 2, "decrypted data(%lu):\n",
-		  (unsigned long)pInfo->cbData);
-	loghex(pCardData, 7, pbuf2, pInfo->cbData);
-
 	/*inversion donnees */
 	/* copy data in constant-time way to prevent leak */
 	for (ui = 0; ui < pbufLen; ui++) {
-		unsigned int mask, msg_index, inv_ui;
-		mask = good & constant_time_lt_s(ui, pInfo->cbData); /* ui should be in the bounds of pbuf2 */
-		inv_ui = pInfo->cbData - ui - 1;
-		msg_index = constant_time_select_s(mask, inv_ui, 0);
-		pInfo->pbData[ui] = constant_time_select_8(mask, pbuf2[msg_index], pInfo->pbData[ui]);
+		unsigned int mask, inv_ui;
+		unsigned char msg_byte, orig_byte;
+		mask = good & constant_time_lt_s(ui, pInfo->cbData);	 /* ui should be in bounds of decrypted message */
+		inv_ui = pInfo->cbData - ui - 1;			 /* compute inversed ui index */
+		msg_byte = pbuf2[constant_time_select(mask, inv_ui, 0)]; /* if in range of decrypted message, read on inversed index otherwise read some bogus value */
+		orig_byte = pInfo->pbData[ui];
+		pInfo->pbData[ui] = constant_time_select_s(mask, msg_byte, orig_byte); /* store message byte only if in correct range */
 	}
 
 	pCardData->pfnCspFree(pbuf);
diff -pruN 0.25.0~rc1-1/src/pkcs15init/pkcs15-epass2003.c 0.25.1-1/src/pkcs15init/pkcs15-epass2003.c
--- 0.25.0~rc1-1/src/pkcs15init/pkcs15-epass2003.c	2024-02-17 23:32:31.000000000 +0000
+++ 0.25.1-1/src/pkcs15init/pkcs15-epass2003.c	2024-04-04 14:21:38.000000000 +0000
@@ -671,7 +671,7 @@ static int epass2003_pkcs15_generate_key
 		struct sc_ec_parameters *ecparams = (struct
 				sc_ec_parameters *)key_info->params.data;
 		pubkey->algorithm = SC_ALGORITHM_EC;
-		pubkey->u.ec.ecpointQ.value = (u8 *) malloc(65);
+		pubkey->u.ec.ecpointQ.value = (u8 *)malloc(gendat.modulus_len + 1);
 		if (!pubkey->u.ec.ecpointQ.value) {
 			r = SC_ERROR_OUT_OF_MEMORY;
 			goto err;
@@ -679,7 +679,7 @@ static int epass2003_pkcs15_generate_key
 
 		pubkey->u.ec.ecpointQ.value[0] = 0x04;
 		memcpy(&pubkey->u.ec.ecpointQ.value[1], gendat.modulus, gendat.modulus_len);
-		pubkey->u.ec.ecpointQ.len = gendat.modulus_len;
+		pubkey->u.ec.ecpointQ.len = gendat.modulus_len + 1;
 		free(gendat.modulus);
 
 		free(pubkey->u.ec.params.named_curve);
diff -pruN 0.25.0~rc1-1/src/tests/p11test/myeid_opensc.conf 0.25.1-1/src/tests/p11test/myeid_opensc.conf
--- 0.25.0~rc1-1/src/tests/p11test/myeid_opensc.conf	2024-02-17 23:32:31.000000000 +0000
+++ 0.25.1-1/src/tests/p11test/myeid_opensc.conf	1970-01-01 00:00:00.000000000 +0000
@@ -1,12 +0,0 @@
-app default {
-	framework pkcs15 {
-		use_file_caching = no;
-	}
-	reader_driver pcsc {
-		# The pinpad is disabled by default,
-		# because of many broken readers out there
-		enable_pinpad = false;
-	}
-	# for pkcs15-init to work in the build directory, we need to point to the directory with the profiles
-	profile_dir = ../../pkcs15init/
-}
diff -pruN 0.25.0~rc1-1/src/tests/p11test/openpgp_s0_ref.json 0.25.1-1/src/tests/p11test/openpgp_s0_ref.json
--- 0.25.0~rc1-1/src/tests/p11test/openpgp_s0_ref.json	2024-02-17 23:32:31.000000000 +0000
+++ 0.25.1-1/src/tests/p11test/openpgp_s0_ref.json	2024-04-04 14:21:38.000000000 +0000
@@ -284,10 +284,10 @@
 		"",
 		"YES",
 		"YES",
-		"YES",
-		"YES",
-		"YES",
-		"YES",
+		"",
+		"",
+		"",
+		"",
 		"",
 		"",
 		""
diff -pruN 0.25.0~rc1-1/src/tests/p11test/p11test_opensc.conf 0.25.1-1/src/tests/p11test/p11test_opensc.conf
--- 0.25.0~rc1-1/src/tests/p11test/p11test_opensc.conf	1970-01-01 00:00:00.000000000 +0000
+++ 0.25.1-1/src/tests/p11test/p11test_opensc.conf	2024-04-04 14:21:38.000000000 +0000
@@ -0,0 +1,12 @@
+app default {
+	framework pkcs15 {
+		use_file_caching = no;
+	}
+	reader_driver pcsc {
+		# The pinpad is disabled by default,
+		# because of many broken readers out there
+		enable_pinpad = false;
+	}
+	# for pkcs15-init to work in the build directory, we need to point to the directory with the profiles
+	profile_dir = ../../pkcs15init/
+}
diff -pruN 0.25.0~rc1-1/src/tests/p11test/runtest.sh 0.25.1-1/src/tests/p11test/runtest.sh
--- 0.25.0~rc1-1/src/tests/p11test/runtest.sh	2024-02-17 23:32:31.000000000 +0000
+++ 0.25.1-1/src/tests/p11test/runtest.sh	2024-04-04 14:21:38.000000000 +0000
@@ -24,7 +24,7 @@ PIN="123456"
 export GNUTLS_PIN=$PIN
 GENERATE_KEYS=1
 PKCS11_TOOL="../../tools/pkcs11-tool";
-PKCS15_INIT="../../tools/pkcs15-init";
+PKCS15_INIT="env OPENSC_CONF=p11test_opensc.conf ../../tools/pkcs15-init"
 SC_HSM_TOOL="../../tools/sc-hsm-tool";
 
 function generate_sym() {
@@ -130,7 +130,6 @@ function card_setup() {
 			;;
 		"myeid")
 			GENERATE_KEYS=0 # we generate them directly here
-			PKCS15_INIT="env OPENSC_CONF=myeid_opensc.conf $PKCS15_INIT"
 			P11LIB="../../pkcs11/.libs/opensc-pkcs11.so"
 			$PKCS15_INIT --erase-card
 			$PKCS15_INIT -C --pin $PIN --puk $SOPIN --so-pin $SOPIN --so-puk $SOPIN
@@ -151,6 +150,18 @@ function card_setup() {
 			$PKCS11_TOOL --module $P11LIB -l --pin $PIN --keypairgen --key-type rsa:2048 --id 10 --label="RSA key"
 			$PKCS11_TOOL --module $P11LIB -l --pin $PIN --keypairgen --key-type EC:prime256v1 --label "EC key"
 			;;
+		"epass2003")
+			GENERATE_KEYS=0 # we generate them directly here
+			P11LIB="../../pkcs11/.libs/opensc-pkcs11.so"
+			PIN="987654"
+			SOPIN="1234567890"
+			$PKCS15_INIT --erase-card -T
+			$PKCS15_INIT --create-pkcs15 -T -p pkcs15+onepin --pin $PIN --puk 1234567890
+			INIT="$PKCS15_INIT --auth-id 01 --so-pin $SOPIN --pin $PIN"
+			$INIT --generate-key ec:prime256v1 --id 01 --label="EC key" --key-usage=sign,keyAgreement
+			$INIT --generate-key rsa:2048 --id 02 --label="RSA key" --key-usage=sign,decrypt
+			$PKCS15_INIT -F
+			;;
 		*)
 			echo "Error: Missing argument."
 			echo "    Usage:"
diff -pruN 0.25.0~rc1-1/src/tests/unittests/strip_pkcs1_2_padding.c 0.25.1-1/src/tests/unittests/strip_pkcs1_2_padding.c
--- 0.25.0~rc1-1/src/tests/unittests/strip_pkcs1_2_padding.c	2024-02-17 23:32:31.000000000 +0000
+++ 0.25.1-1/src/tests/unittests/strip_pkcs1_2_padding.c	2024-04-04 14:21:38.000000000 +0000
@@ -18,6 +18,7 @@ torture_long_output_buffer(void **state)
 	unsigned char result_msg[] = {'m', 's', 'g'};
 	int r = sc_pkcs1_strip_02_padding_constant_time(NULL, n, in, in_len, out, &out_len);
 	assert_int_equal(r, 3);
+	assert_int_equal(r, (int)out_len);
 	assert_memory_equal(out, result_msg, r);
 	free(out);
 }
@@ -34,6 +35,7 @@ torture_short_output_buffer(void **state
 	unsigned int out_len = 1;
 	unsigned char *out = calloc(out_len, sizeof(unsigned char));
 	int r = sc_pkcs1_strip_02_padding_constant_time(NULL, n, in, in_len, out, &out_len);
+	assert_int_equal((int)out_len, 1);
 	assert_int_equal(r, SC_ERROR_WRONG_PADDING);
 	free(out);
 }
@@ -52,6 +54,7 @@ torture_short_message_correct_padding(vo
 	unsigned char result_msg[] = {'m', 's', 'g'};
 	int r = sc_pkcs1_strip_02_padding_constant_time(NULL, n, in, in_len, out, &out_len);
 	assert_int_equal(r, 3);
+	assert_int_equal(r, (int)out_len);
 	assert_memory_equal(out, result_msg, r);
 	free(out);
 }
@@ -68,6 +71,7 @@ torture_missing_first_zero(void **state)
 	unsigned int out_len = 10;
 	unsigned char *out = calloc(out_len, sizeof(unsigned char));
 	int r = sc_pkcs1_strip_02_padding_constant_time(NULL, n, in, in_len, out, &out_len);
+	assert_int_equal((int)out_len, 10);
 	assert_int_equal(r, SC_ERROR_WRONG_PADDING);
 	free(out);
 }
@@ -84,6 +88,7 @@ torture_missing_two(void **state)
 	unsigned int out_len = 10;
 	unsigned char *out = calloc(out_len, sizeof(unsigned char));
 	int r = sc_pkcs1_strip_02_padding_constant_time(NULL, n, in, in_len, out, &out_len);
+	assert_int_equal((int)out_len, 10);
 	assert_int_equal(r, SC_ERROR_WRONG_PADDING);
 	free(out);
 }
@@ -100,6 +105,7 @@ torture_short_padding(void **state)
 	unsigned int out_len = 10;
 	unsigned char *out = calloc(out_len, sizeof(unsigned char));
 	int r = sc_pkcs1_strip_02_padding_constant_time(NULL, n, in, in_len, out, &out_len);
+	assert_int_equal((int)out_len, 10);
 	assert_int_equal(r, SC_ERROR_WRONG_PADDING);
 	free(out);
 }
@@ -115,6 +121,7 @@ torture_missing_second_zero(void **state
 	unsigned int out_len = 10;
 	unsigned char *out = calloc(out_len, sizeof(unsigned char));
 	int r = sc_pkcs1_strip_02_padding_constant_time(NULL, n, in, in_len, out, &out_len);
+	assert_int_equal((int)out_len, 10);
 	assert_int_equal(r, SC_ERROR_WRONG_PADDING);
 	free(out);
 }
@@ -130,6 +137,7 @@ torture_missing_message(void **state)
 	unsigned int out_len = 11;
 	unsigned char *out = calloc(out_len, sizeof(unsigned char));
 	int r = sc_pkcs1_strip_02_padding_constant_time(NULL, n, in, in_len, out, &out_len);
+	assert_int_equal((int)out_len, 11);
 	assert_int_equal(r, SC_ERROR_WRONG_PADDING);
 	free(out);
 }
@@ -148,6 +156,7 @@ torture_one_byte_message(void **state)
 	unsigned char result_msg[] = {'m'};
 	int r = sc_pkcs1_strip_02_padding_constant_time(NULL, n, in, in_len, out, &out_len);
 	assert_int_equal(r, 1);
+	assert_int_equal(r, (int)out_len);
 	assert_memory_equal(out, result_msg, r);
 	free(out);
 }
@@ -166,6 +175,7 @@ torture_longer_padding(void **state)
 	unsigned char result_msg[] = {0x9d, 0x98, 0x3d, 0xca, 0xa9, 0xa7, 0x11, 0x0a};
 	int r = sc_pkcs1_strip_02_padding_constant_time(NULL, n, in, in_len, out, &out_len);
 	assert_int_equal(r, 8);
+	assert_int_equal(r, (int)out_len);
 	assert_memory_equal(out, result_msg, r);
 	free(out);
 }
@@ -181,6 +191,7 @@ torture_empty_message(void **state)
 	unsigned int out_len = 8;
 	unsigned char *out = calloc(out_len, sizeof(unsigned char));
 	int r = sc_pkcs1_strip_02_padding_constant_time(NULL, n, in, in_len, out, &out_len);
+	assert_int_equal((int)out_len, 0);
 	assert_int_equal(r, 0);
 	free(out);
 }
diff -pruN 0.25.0~rc1-1/src/tools/Makefile.am 0.25.1-1/src/tools/Makefile.am
--- 0.25.0~rc1-1/src/tools/Makefile.am	2024-02-17 23:32:31.000000000 +0000
+++ 0.25.1-1/src/tools/Makefile.am	2024-04-04 14:21:38.000000000 +0000
@@ -30,7 +30,8 @@ noinst_HEADERS = util.h fread_to_eof.h \
 	openpgp-tool-helpers.h
 bin_PROGRAMS = opensc-tool opensc-explorer opensc-asn1 \
 	pkcs15-tool pkcs15-crypt pkcs11-tool pkcs11-register \
-	cardos-tool eidenv openpgp-tool iasecc-tool egk-tool goid-tool
+	cardos-tool eidenv openpgp-tool iasecc-tool egk-tool goid-tool \
+	dtrust-tool
 if ENABLE_OPENSSL
 bin_PROGRAMS += cryptoflex-tool pkcs15-init netkey-tool piv-tool \
 	westcos-tool sc-hsm-tool dnie-tool gids-tool
@@ -127,6 +128,8 @@ if HAVE_UNKNOWN_WARNING_OPTION
 goid_tool_CFLAGS += -Wno-unknown-warning-option
 endif
 
+dtrust_tool_SOURCES = dtrust-tool.c util.c
+
 opensc_asn1_SOURCES = opensc-asn1.c fread_to_eof.c opensc-asn1-cmdline.c
 if HAVE_UNKNOWN_WARNING_OPTION
 opensc_asn1_CFLAGS = -Wno-unknown-warning-option
diff -pruN 0.25.0~rc1-1/src/tools/Makefile.mak 0.25.1-1/src/tools/Makefile.mak
--- 0.25.0~rc1-1/src/tools/Makefile.mak	2024-02-17 23:32:31.000000000 +0000
+++ 0.25.1-1/src/tools/Makefile.mak	2024-04-04 14:21:38.000000000 +0000
@@ -6,8 +6,8 @@ default: all
 
 TARGETS = opensc-tool.exe opensc-explorer.exe pkcs15-tool.exe pkcs15-crypt.exe \
 		pkcs11-tool.exe cardos-tool.exe eidenv.exe openpgp-tool.exe iasecc-tool.exe \
-		opensc-notify.exe egk-tool.exe goid-tool.exe paccess-tool.exe opensc-asn1.exe \
-		pkcs11-register.exe $(PROGRAMS_OPENSSL) $(PROGRAMS_OPENPACE)
+		opensc-notify.exe egk-tool.exe goid-tool.exe dtrust-tool paccess-tool.exe \
+		opensc-asn1.exe pkcs11-register.exe $(PROGRAMS_OPENSSL) $(PROGRAMS_OPENPACE)
 
 OBJECTS = util.obj versioninfo-tools.res
 
diff -pruN 0.25.0~rc1-1/src/tools/dtrust-tool.c 0.25.1-1/src/tools/dtrust-tool.c
--- 0.25.0~rc1-1/src/tools/dtrust-tool.c	1970-01-01 00:00:00.000000000 +0000
+++ 0.25.1-1/src/tools/dtrust-tool.c	2024-04-04 14:21:38.000000000 +0000
@@ -0,0 +1,318 @@
+/*
+ * dtrust-tool.c: tool for D-Trust cards
+ *
+ * Copyright (C) 2024 mario.haustein@hrz.tu-chemnitz.de
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include "config.h"
+
+#include <stdio.h>
+#include <string.h>
+
+#include "libopensc/opensc.h"
+
+#include "libopensc/cards.h"
+#include "libopensc/errors.h"
+
+#include "util.h"
+
+static const char *app_name = "dtrust-tool";
+
+// clang-format off
+static const struct option options[] = {
+	{"reader", 1, NULL, 'r'},
+	{"wait", 0, NULL, 'w'},
+	{"pin-status", 0, NULL, 's'},
+	{"check-transport-protection", 0, NULL, 'c'},
+	{"unlock-transport-protection", 0, NULL, 'u'},
+	{"help", 0, NULL, 'h'},
+	{"verbose", 0, NULL, 'v'},
+	{NULL, 0, NULL, 0}
+};
+
+static const char *option_help[] = {
+	"Uses reader number <arg> [0]",
+	"Wait for card insertion",
+	"Show PIN status",
+	"Check transport protection",
+	"Unlock transport protection",
+	"This message",
+	"Verbose operation, may be used several times",
+};
+// clang-format on
+
+static const char *opt_reader = NULL;
+static int opt_wait = 0, verbose = 0;
+static int opt_status = 0;
+static int opt_check = 0;
+static int opt_unlock = 0;
+
+void
+pin_status(sc_card_t *card, int ref, const char *pin_label)
+{
+	int r;
+	struct sc_pin_cmd_data data;
+	int tries_left = 0;
+
+	memset(&data, 0, sizeof(data));
+	data.cmd = SC_PIN_CMD_GET_INFO;
+	data.pin_type = SC_AC_CHV;
+	data.pin_reference = ref;
+
+	r = sc_pin_cmd(card, &data, &tries_left);
+
+	if (r == SC_SUCCESS) {
+		if (tries_left < 0)
+			printf("%s: usable\n", pin_label);
+		else
+			printf("%s: usable (%d tries left)\n", pin_label, tries_left);
+	} else if (r == SC_ERROR_SECURITY_STATUS_NOT_SATISFIED)
+		printf("%s: not usable (transport protection still in force)\n", pin_label);
+	else if (r == SC_ERROR_AUTH_METHOD_BLOCKED)
+		printf("%s: blocked (use PUK to unblock PIN)\n", pin_label);
+	else if (r == SC_ERROR_REF_DATA_NOT_USABLE)
+		printf("%s: not usable (transport protection already broken)\n", pin_label);
+	else
+		fprintf(stderr, "%s: status query failed (%s).\n", pin_label, sc_strerror(r));
+}
+
+int
+check_transport_protection(sc_card_t *card)
+{
+	struct sc_apdu apdu;
+	int r;
+	u8 buf[6];
+	u8 prot_intact[6] = {0xE3, 0x04, 0x90, 0x02, 0x00, 0x01};
+	u8 prot_broken[6] = {0xE3, 0x04, 0x90, 0x02, 0x00, 0x00};
+
+	sc_format_apdu_ex(&apdu, 0x80, 0xCA, 0x00, 0x0B, NULL, 0, buf, sizeof(buf));
+
+	r = sc_transmit_apdu(card, &apdu);
+	if (r != SC_SUCCESS) {
+		fprintf(stderr, "Check transport protection: APDU transmit failed (%s)\n", sc_strerror(r));
+		return -1;
+	}
+
+	r = sc_check_sw(card, apdu.sw1, apdu.sw2);
+	if (r != SC_SUCCESS) {
+		fprintf(stderr, "Check transport protection: GET_DATA failed (%s)\n", sc_strerror(r));
+		return -1;
+	}
+
+	if (apdu.resplen == sizeof(prot_intact) && !memcmp(apdu.resp, prot_intact, 6)) {
+		printf("Transport protection is still intact.\n");
+		return 0;
+	} else if (apdu.resplen == sizeof(prot_broken) && !memcmp(apdu.resp, prot_broken, 6)) {
+		printf("Transport protection is broken.\n");
+		return 1;
+	}
+
+	fprintf(stderr, "Check transport protection: illegal response: ");
+	util_hex_dump(stderr, apdu.resp, apdu.resplen, " ");
+	fprintf(stderr, "\n");
+
+	return -1;
+}
+
+void
+unlock_transport_protection(sc_card_t *card)
+{
+	struct sc_pin_cmd_data data;
+	int r;
+	char *tpin = NULL;
+	char *qespin1 = NULL;
+	char *qespin2 = NULL;
+	size_t tpin_len = 0;
+	size_t qespin1_len = 0;
+	size_t qespin2_len = 0;
+	int tries_left;
+
+	memset(&data, 0, sizeof(data));
+	data.cmd = SC_PIN_CMD_CHANGE;
+	data.pin_type = SC_AC_CHV;
+	data.pin_reference = 0x87;
+	data.pin1.min_length = 5;
+	data.pin1.max_length = 5;
+	data.pin2.min_length = 6;
+	data.pin2.max_length = 12;
+
+	if (card->reader->capabilities & SC_READER_CAP_PIN_PAD) {
+		printf("Please enter PINs on the reader's pin pad.\n");
+		data.pin1.prompt = "Enter Transport PIN";
+		data.pin2.prompt = "Enter Signature PIN";
+		data.flags |= SC_PIN_CMD_USE_PINPAD;
+	} else {
+		printf("Enter Transport PIN:");
+		r = util_getpass(&tpin, &tpin_len, stdin);
+		if (r < 0 || tpin == NULL) {
+			fprintf(stderr, "Unable to get PIN");
+			return;
+		}
+
+		printf("Enter new Signature PIN:");
+		r = util_getpass(&qespin1, &qespin1_len, stdin);
+		if (r < 0 || qespin1 == NULL) {
+			fprintf(stderr, "Unable to get PIN");
+			goto fail_qespin1;
+		}
+
+		printf("Enter new Signature PIN again:");
+		r = util_getpass(&qespin2, &qespin1_len, stdin);
+		if (r < 0 || qespin2 == NULL) {
+			fprintf(stderr, "Unable to get PIN");
+			goto fail_qespin2;
+		}
+
+		if (strcmp(qespin1, qespin2)) {
+			fprintf(stderr, "New signature PINs doesn't match.\n");
+			goto fail_qespin2;
+		}
+		data.pin1.data = (u8 *)tpin;
+		data.pin1.len = strlen(tpin);
+		data.pin2.data = (u8 *)qespin1;
+		data.pin2.len = strlen(qespin1);
+	}
+
+	r = sc_pin_cmd(card, &data, &tries_left);
+
+	if (r == SC_SUCCESS)
+		printf("Transport protection removed. You can now use your Signature PIN.\n");
+	else if (r == SC_ERROR_PIN_CODE_INCORRECT)
+		printf("Wrong pin. %d attempts left.\n", tries_left);
+	else
+		printf("Can't change pin: %s\n", sc_strerror(r));
+
+	if (qespin2 != NULL) {
+		sc_mem_clear(qespin2, qespin2_len);
+		free(qespin2);
+	}
+
+fail_qespin2:
+	if (qespin1 != NULL) {
+		sc_mem_clear(qespin1, qespin1_len);
+		free(qespin1);
+	}
+
+fail_qespin1:
+	if (tpin != NULL) {
+		sc_mem_clear(tpin, tpin_len);
+		free(tpin);
+	}
+}
+
+int
+main(int argc, char *argv[])
+{
+	int r, c, long_optind = 0;
+	sc_context_param_t ctx_param;
+	sc_card_t *card = NULL;
+	sc_context_t *ctx = NULL;
+	sc_path_t path;
+
+	while (1) {
+		c = getopt_long(argc, argv, "r:wscuhv", options, &long_optind);
+
+		if (c == -1)
+			break;
+
+		if (c == '?' || c == 'h')
+			util_print_usage_and_die(app_name, options, option_help, NULL);
+
+		switch (c) {
+		case 'r':
+			opt_reader = optarg;
+			break;
+		case 'w':
+			opt_wait = 1;
+			break;
+		case 's':
+			opt_status = 1;
+			break;
+		case 'c':
+			opt_check = 1;
+			break;
+		case 'u':
+			opt_unlock = 1;
+			break;
+		case 'v':
+			verbose++;
+			break;
+		}
+	}
+
+	memset(&ctx_param, 0, sizeof(ctx_param));
+	ctx_param.ver = 0;
+	ctx_param.app_name = argv[0];
+	ctx_param.debug = verbose;
+	if (verbose)
+		ctx_param.debug_file = stderr;
+
+	r = sc_context_create(&ctx, &ctx_param);
+	if (r) {
+		printf("Failed to establish context: %s\n", sc_strerror(r));
+		return 1;
+	}
+
+	r = sc_set_card_driver(ctx, "dtrust");
+	if (r) {
+		printf("Driver 'dtrust' not found!\n");
+		goto out;
+	}
+
+	r = util_connect_card(ctx, &card, opt_reader, opt_wait);
+	if (r)
+		goto out;
+
+	/*
+	 * We have to select the QES app to verify and change the QES PIN.
+	 */
+	sc_format_path("3F000101", &path);
+	r = sc_select_file(card, &path, NULL);
+	if (r)
+		goto out;
+
+	if (opt_status) {
+		if (card->type == SC_CARD_TYPE_DTRUST_V4_1_STD ||
+				card->type == SC_CARD_TYPE_DTRUST_V4_1_MULTI ||
+				card->type == SC_CARD_TYPE_DTRUST_V4_1_M100)
+			pin_status(card, 0x03, "Card Holder PIN");
+		pin_status(card, 0x04, "Card Holder PUK");
+		pin_status(card, 0x87, "Signature PIN");
+		pin_status(card, 0x8B, "Transport PIN");
+	}
+
+	if (opt_check)
+		check_transport_protection(card);
+
+	if (opt_unlock) {
+		r = check_transport_protection(card);
+		if (r)
+			printf("Cannot remove transport protection.\n");
+		else
+			unlock_transport_protection(card);
+	}
+
+out:
+	if (card) {
+		sc_unlock(card);
+		sc_disconnect_card(card);
+	}
+
+	sc_release_context(ctx);
+
+	return EXIT_SUCCESS;
+}
diff -pruN 0.25.0~rc1-1/src/tools/piv-tool.c 0.25.1-1/src/tools/piv-tool.c
--- 0.25.0~rc1-1/src/tools/piv-tool.c	2024-02-17 23:32:31.000000000 +0000
+++ 0.25.1-1/src/tools/piv-tool.c	2024-04-04 14:21:38.000000000 +0000
@@ -532,6 +532,7 @@ static int gen_key(const char * key_info
 		EVP_PKEY_CTX_free(ctx);
 		OSSL_PARAM_free(params);
 #endif
+#else  /* OPENSSL_NO_EC */
 		fprintf(stderr, "This build of OpenSSL does not support EC keys\n");
 		r = 1;
 #endif /* OPENSSL_NO_EC */
diff -pruN 0.25.0~rc1-1/src/tools/pkcs11-tool.c 0.25.1-1/src/tools/pkcs11-tool.c
--- 0.25.0~rc1-1/src/tools/pkcs11-tool.c	2024-02-17 23:32:31.000000000 +0000
+++ 0.25.1-1/src/tools/pkcs11-tool.c	2024-04-04 14:21:38.000000000 +0000
@@ -7125,7 +7125,7 @@ static int test_verify(CK_SESSION_HANDLE
 	return errors;
 }
 
-#if OPENSC_VERSION_MAJOR == 0 && OPENSC_VERSION_MINOR <= 24
+#if OPENSC_VERSION_MAJOR == 0 && OPENSC_VERSION_MINOR <= 25
 #else
 #ifdef ENABLE_OPENSSL
 static int wrap_unwrap(CK_SESSION_HANDLE session,
@@ -7249,7 +7249,7 @@ static int wrap_unwrap(CK_SESSION_HANDLE
  */
 static int test_unwrap(CK_SESSION_HANDLE sess)
 {
-#if OPENSC_VERSION_MAJOR == 0 && OPENSC_VERSION_MINOR <= 24
+#if OPENSC_VERSION_MAJOR == 0 && OPENSC_VERSION_MINOR <= 25
 	/* temporarily disable test, see https://github.com/OpenSC/OpenSC/issues/1796 */
 	return 0;
 #else
